module A2Z_SPI(
	input clk_in,
	input SPI_in,
	input [7:0] data_in,
	input WR_enable,
	output SPI_clk,
	output SPI_out,
	output [7:0] data_out
);

	reg [7:0] shift_reg_TX;
	reg [7:0] shift_reg_RX;
	reg [4:0] loc_counter;
	
	assign SPI_out = shift_reg_TX[7];
	assign SPI_clk = loc_counter[0];
	assign data_out = shift_reg_RX[7:0];
	
	always @(posedge clk_in) begin
		if ((WR_enable == 1'b1)&&(loc_counter==5'd17))
			loc_counter <= 5'b1;
		else if (loc_counter!=5'd17) 
			loc_counter <= loc_counter + 5'b1;
	end
	
	always @(posedge clk_in) begin
		if ((WR_enable == 1'b1)&&(loc_counter==5'd17))
			shift_reg_TX <= data_in;
		else if ((loc_counter[0] == 1'b1)&&(loc_counter!=5'd17)&&(loc_counter!=5'd1)) 
			shift_reg_TX <= {shift_reg_TX[6:0],1'b0};
		else if (loc_counter[0] == 1'b0)
			shift_reg_RX <= {shift_reg_RX[6:0],SPI_in};
	end
	
endmodule