module VGA_palette (
	input [1:0] color, 
	input [1:0] lum, 
	output reg [3:0] to_CNA
);
	wire [3:0] my_input;
	assign my_input = {color, lum};
	
	always @(*) begin
		case (my_input)
			4'b0000 : to_CNA <= 4'd0;
			4'b0001 : to_CNA <= 4'd0;
			4'b0010 : to_CNA <= 4'd0;
			4'b0011 : to_CNA <= 4'd0;
			
			4'b0100 : to_CNA <= 4'd2;//1
			4'b0101 : to_CNA <= 4'd3;//2
			4'b0110 : to_CNA <= 4'd4;//3
			4'b0111 : to_CNA <= 4'd5;//4
			
			4'b1000 : to_CNA <= 4'd4;//2
			4'b1001 : to_CNA <= 4'd6;//4
			4'b1010 : to_CNA <= 4'd8;//6
			4'b1011 : to_CNA <= 4'd10;//8
			
			4'b1100 : to_CNA <= 4'd6;//3
			4'b1101 : to_CNA <= 4'd9;//6
			4'b1110 : to_CNA <= 4'd12;//9
			4'b1111 : to_CNA <= 4'd15;//12
		endcase
	end
	
endmodule