# Copyright (C) 1991-2011 Altera Corporation
# Your use of Altera Corporation's design tools, logic functions 
# and other software and tools, and its AMPP partner logic 
# functions, and any output files from any of the foregoing 
# (including device programming or simulation files), and any 
# associated documentation or information are expressly subject 
# to the terms and conditions of the Altera Program License 
# Subscription Agreement, Altera MegaCore Function License 
# Agreement, or other applicable license agreement, including, 
# without limitation, that your use is for the sole purpose of 
# programming logic devices manufactured by Altera and sold by 
# Altera or its authorized distributors.  Please refer to the 
# applicable agreement for further details.

# Quartus II: Generate Tcl File for Project
# File: top_A2Z.tcl
# Generated on: Mon Oct 26 20:13:15 2015

# Load Quartus II Tcl Project package
package require ::quartus::project

set need_to_close_project 0
set make_assignments 1

# Check that the right project is open
if {[is_project_open]} {
	if {[string compare $quartus(project) "top_A2Z"]} {
		puts "Project top_A2Z is not open"
		set make_assignments 0
	}
} else {
	# Only open if not already open
	if {[project_exists top_A2Z]} {
		project_open -revision top_A2Z top_A2Z
	} else {
		project_new -revision top_A2Z top_A2Z
	}
	set need_to_close_project 1
}

# Make assignments
if {$make_assignments} {
	set_global_assignment -name FAMILY "Cyclone IV E"
	set_global_assignment -name DEVICE EP4CE6E22C8
	set_global_assignment -name ORIGINAL_QUARTUS_VERSION "11.1 SP2"
	set_global_assignment -name PROJECT_CREATION_TIME_DATE "14:18:00  AUGUST 22, 2015"
	set_global_assignment -name LAST_QUARTUS_VERSION "11.1 SP2"
	set_global_assignment -name MIN_CORE_JUNCTION_TEMP 0
	set_global_assignment -name MAX_CORE_JUNCTION_TEMP 85
	set_global_assignment -name ERROR_CHECK_FREQUENCY_DIVISOR 1
	set_global_assignment -name NOMINAL_CORE_SUPPLY_VOLTAGE 1.2V
	set_global_assignment -name EDA_SIMULATION_TOOL "ModelSim-Altera (Verilog)"
	set_global_assignment -name EDA_OUTPUT_DATA_FORMAT "VERILOG HDL" -section_id eda_simulation
	set_global_assignment -name PARTITION_NETLIST_TYPE SOURCE -section_id Top
	set_global_assignment -name PARTITION_FITTER_PRESERVATION_LEVEL PLACEMENT_AND_ROUTING -section_id Top
	set_global_assignment -name PARTITION_COLOR 16764057 -section_id Top
	set_global_assignment -name STRATIX_DEVICE_IO_STANDARD "2.5 V"
	set_global_assignment -name POWER_PRESET_COOLING_SOLUTION "23 MM HEAT SINK WITH 200 LFPM AIRFLOW"
	set_global_assignment -name POWER_BOARD_THERMAL_MODEL "NONE (CONSERVATIVE)"
	set_global_assignment -name VERILOG_FILE top_A2Z.v
	set_global_assignment -name VERILOG_FILE ../core_A2Z/core_A2Z.v
	set_global_assignment -name HEX_FILE boot_RAM_content.hex
	set_global_assignment -name QIP_FILE ../core_A2Z/core_cache.qip
	set_global_assignment -name QIP_FILE Boot_RAM.qip
	set_global_assignment -name VERILOG_FILE ../VGA_A2Z/essai_VGA.v
	set_global_assignment -name MIF_FILE ../VGA_A2Z/TEXT_init.mif
	set_global_assignment -name MIF_FILE ../VGA_A2Z/char_ROM_content_05.mif
	set_global_assignment -name QIP_FILE ../VGA_A2Z/char_ROM.qip
	set_global_assignment -name QIP_FILE ../VGA_A2Z/text_RAM.qip
	set_global_assignment -name VERILOG_FILE ../core_A2Z/ALU/ALU_A2Z.v
	set_global_assignment -name QIP_FILE ../core_A2Z/ALU/ADD_1.qip
	set_global_assignment -name VERILOG_FILE ../core_A2Z/ALU/ADD_1.v
	set_global_assignment -name QIP_FILE ../core_A2Z/ALU/compare_01.qip
	set_global_assignment -name VERILOG_FILE ../core_A2Z/ALU/compare_01.v
	set_global_assignment -name MIF_FILE Boot_RAM_content_01.mif
	set_global_assignment -name QIP_FILE ../core_A2Z/address_add/add_8_full.qip
	set_global_assignment -name VERILOG_FILE ../core_A2Z/address_add/addr_adder.v
	set_global_assignment -name VERILOG_FILE ../core_A2Z/address_add/add_8_full.v
	set_global_assignment -name QIP_FILE ../core_A2Z/address_add/add_8_const.qip
	set_global_assignment -name VERILOG_FILE ../core_A2Z/address_add/add_8_const.v
	set_global_assignment -name QIP_FILE ../core_A2Z/address_add/add_9_full.qip
	set_global_assignment -name QIP_FILE ../core_A2Z/address_add/add_7_const.qip
	set_global_assignment -name VERILOG_FILE ../core_A2Z/address_add/PC_adder.v
	set_global_assignment -name QIP_FILE main_pll.qip
	set_global_assignment -name VERILOG_FILE main_pll.v
	set_global_assignment -name SDC_FILE top_A2Z.sdc
	set_global_assignment -name QIP_FILE ../VGA_A2Z/add_VGA_low.qip
	set_global_assignment -name QIP_FILE ../VGA_A2Z/add_VGA_high.qip
	set_global_assignment -name VERILOG_FILE ../VGA_A2Z/add_VGA_full.v
	set_global_assignment -name VERILOG_FILE ../VGA_A2Z/VGA_palette.v
	set_global_assignment -name VERILOG_FILE ../PS2_A2Z/PS2_A2Z.v
	set_location_assignment PIN_23 -to clk_in_l
	set_location_assignment PIN_125 -to reset_in_l
	set_instance_assignment -name IO_STANDARD "3.3-V LVTTL" -to clk_in_l
	set_instance_assignment -name IO_STANDARD "3.3-V LVTTL" -to reset_in_l
	set_location_assignment PIN_11 -to led_HALT
	set_location_assignment PIN_65 -to H_sync
	set_location_assignment PIN_60 -to V_sync
	set_location_assignment PIN_70 -to blue[3]
	set_location_assignment PIN_68 -to blue[2]
	set_location_assignment PIN_66 -to blue[1]
	set_location_assignment PIN_64 -to blue[0]
	set_location_assignment PIN_59 -to green[3]
	set_location_assignment PIN_55 -to green[2]
	set_location_assignment PIN_58 -to green[1]
	set_location_assignment PIN_54 -to green[0]
	set_location_assignment PIN_72 -to red[3]
	set_location_assignment PIN_71 -to red[2]
	set_location_assignment PIN_69 -to red[1]
	set_location_assignment PIN_67 -to red[0]
	set_instance_assignment -name IO_STANDARD "3.3-V LVTTL" -to red[0]
	set_instance_assignment -name IO_STANDARD "3.3-V LVTTL" -to red[1]
	set_instance_assignment -name IO_STANDARD "3.3-V LVTTL" -to red[2]
	set_instance_assignment -name IO_STANDARD "3.3-V LVTTL" -to red[3]
	set_instance_assignment -name IO_STANDARD "3.3-V LVTTL" -to led_HALT
	set_instance_assignment -name IO_STANDARD "3.3-V LVTTL" -to green[0]
	set_instance_assignment -name IO_STANDARD "3.3-V LVTTL" -to green[1]
	set_instance_assignment -name IO_STANDARD "3.3-V LVTTL" -to green[2]
	set_instance_assignment -name IO_STANDARD "3.3-V LVTTL" -to green[3]
	set_instance_assignment -name IO_STANDARD "3.3-V LVTTL" -to H_sync
	set_instance_assignment -name IO_STANDARD "3.3-V LVTTL" -to V_sync
	set_instance_assignment -name IO_STANDARD "3.3-V LVTTL" -to blue[3]
	set_instance_assignment -name IO_STANDARD "3.3-V LVTTL" -to blue[2]
	set_instance_assignment -name IO_STANDARD "3.3-V LVTTL" -to blue[1]
	set_instance_assignment -name IO_STANDARD "3.3-V LVTTL" -to blue[0]
	set_instance_assignment -name IO_STANDARD "3.3-V LVTTL" -to CS_out[4]
	set_instance_assignment -name IO_STANDARD "3.3-V LVTTL" -to CS_out[3]
	set_instance_assignment -name IO_STANDARD "3.3-V LVTTL" -to CS_out[2]
	set_instance_assignment -name IO_STANDARD "3.3-V LVTTL" -to CS_out[1]
	set_instance_assignment -name IO_STANDARD "3.3-V LVTTL" -to OE_out
	set_instance_assignment -name IO_STANDARD "3.3-V LVTTL" -to WR_out
	set_instance_assignment -name IO_STANDARD "3.3-V LVTTL" -to address_out[18]
	set_instance_assignment -name IO_STANDARD "3.3-V LVTTL" -to address_out[17]
	set_instance_assignment -name IO_STANDARD "3.3-V LVTTL" -to address_out[16]
	set_instance_assignment -name IO_STANDARD "3.3-V LVTTL" -to address_out[15]
	set_instance_assignment -name IO_STANDARD "3.3-V LVTTL" -to address_out[14]
	set_instance_assignment -name IO_STANDARD "3.3-V LVTTL" -to address_out[13]
	set_instance_assignment -name IO_STANDARD "3.3-V LVTTL" -to address_out[12]
	set_instance_assignment -name IO_STANDARD "3.3-V LVTTL" -to address_out[11]
	set_instance_assignment -name IO_STANDARD "3.3-V LVTTL" -to address_out[10]
	set_instance_assignment -name IO_STANDARD "3.3-V LVTTL" -to address_out[9]
	set_instance_assignment -name IO_STANDARD "3.3-V LVTTL" -to address_out[8]
	set_instance_assignment -name IO_STANDARD "3.3-V LVTTL" -to address_out[7]
	set_instance_assignment -name IO_STANDARD "3.3-V LVTTL" -to address_out[6]
	set_instance_assignment -name IO_STANDARD "3.3-V LVTTL" -to address_out[5]
	set_instance_assignment -name IO_STANDARD "3.3-V LVTTL" -to address_out[4]
	set_instance_assignment -name IO_STANDARD "3.3-V LVTTL" -to address_out[3]
	set_instance_assignment -name IO_STANDARD "3.3-V LVTTL" -to address_out[2]
	set_instance_assignment -name IO_STANDARD "3.3-V LVTTL" -to address_out[1]
	set_instance_assignment -name IO_STANDARD "3.3-V LVTTL" -to address_out[0]
	set_instance_assignment -name IO_STANDARD "3.3-V LVTTL" -to data_out[15]
	set_instance_assignment -name IO_STANDARD "3.3-V LVTTL" -to data_out[14]
	set_instance_assignment -name IO_STANDARD "3.3-V LVTTL" -to data_out[13]
	set_instance_assignment -name IO_STANDARD "3.3-V LVTTL" -to data_out[12]
	set_instance_assignment -name IO_STANDARD "3.3-V LVTTL" -to data_out[11]
	set_instance_assignment -name IO_STANDARD "3.3-V LVTTL" -to data_out[10]
	set_instance_assignment -name IO_STANDARD "3.3-V LVTTL" -to data_out[9]
	set_instance_assignment -name IO_STANDARD "3.3-V LVTTL" -to data_out[8]
	set_instance_assignment -name IO_STANDARD "3.3-V LVTTL" -to data_out[7]
	set_instance_assignment -name IO_STANDARD "3.3-V LVTTL" -to data_out[6]
	set_instance_assignment -name IO_STANDARD "3.3-V LVTTL" -to data_out[5]
	set_instance_assignment -name IO_STANDARD "3.3-V LVTTL" -to data_out[4]
	set_instance_assignment -name IO_STANDARD "3.3-V LVTTL" -to data_out[3]
	set_instance_assignment -name IO_STANDARD "3.3-V LVTTL" -to data_out[2]
	set_instance_assignment -name IO_STANDARD "3.3-V LVTTL" -to data_out[1]
	set_instance_assignment -name IO_STANDARD "3.3-V LVTTL" -to data_out[0]
	set_location_assignment PIN_110 -to CS_out[4]
	set_location_assignment PIN_111 -to CS_out[3]
	set_location_assignment PIN_112 -to CS_out[2]
	set_location_assignment PIN_113 -to CS_out[1]
	set_location_assignment PIN_2 -to OE_out
	set_location_assignment PIN_1 -to WR_out
	set_location_assignment PIN_115 -to address_out[18]
	set_location_assignment PIN_119 -to address_out[17]
	set_location_assignment PIN_120 -to address_out[16]
	set_location_assignment PIN_121 -to address_out[15]
	set_location_assignment PIN_124 -to address_out[14]
	set_location_assignment PIN_126 -to address_out[13]
	set_location_assignment PIN_127 -to address_out[12]
	set_location_assignment PIN_128 -to address_out[11]
	set_location_assignment PIN_129 -to address_out[10]
	set_location_assignment PIN_132 -to address_out[9]
	set_location_assignment PIN_133 -to address_out[8]
	set_location_assignment PIN_135 -to address_out[7]
	set_location_assignment PIN_136 -to address_out[6]
	set_location_assignment PIN_137 -to address_out[5]
	set_location_assignment PIN_138 -to address_out[4]
	set_location_assignment PIN_141 -to address_out[3]
	set_location_assignment PIN_142 -to address_out[2]
	set_location_assignment PIN_143 -to address_out[1]
	set_location_assignment PIN_144 -to address_out[0]
	set_location_assignment PIN_28 -to data_out[15]
	set_location_assignment PIN_30 -to data_out[14]
	set_location_assignment PIN_31 -to data_out[13]
	set_location_assignment PIN_32 -to data_out[12]
	set_location_assignment PIN_33 -to data_out[11]
	set_location_assignment PIN_34 -to data_out[10]
	set_location_assignment PIN_38 -to data_out[9]
	set_location_assignment PIN_39 -to data_out[8]
	set_location_assignment PIN_42 -to data_out[7]
	set_location_assignment PIN_43 -to data_out[6]
	set_location_assignment PIN_44 -to data_out[5]
	set_location_assignment PIN_46 -to data_out[4]
	set_location_assignment PIN_49 -to data_out[3]
	set_location_assignment PIN_50 -to data_out[2]
	set_location_assignment PIN_51 -to data_out[1]
	set_location_assignment PIN_52 -to data_out[0]
	set_location_assignment PIN_105 -to PS2_clk_pin
	set_location_assignment PIN_106 -to PS2_data_pin
	set_instance_assignment -name IO_STANDARD "3.3-V LVTTL" -to PS2_data_pin
	set_instance_assignment -name IO_STANDARD "3.3-V LVTTL" -to PS2_clk_pin
	set_instance_assignment -name PARTITION_HIERARCHY root_partition -to | -section_id Top

	# Commit assignments
	export_assignments

	# Close project
	if {$need_to_close_project} {
		project_close
	}
}
