// Assembler_A2Z_001.cpp: 

#include "stdafx.h"
#include "stdio.h"
#include "string.h"



void read_micro_address(const char* ASM_micro_addr, char* BIN_micro_addr) {
	int i,j;
	char* toto;
	if (strcmp(ASM_micro_addr, "B") == 0) {			strcpy(BIN_micro_addr,"78");}
	if (strcmp(ASM_micro_addr, "ext_A") == 0) {		strcpy(BIN_micro_addr,"00");}
	if (strcmp(ASM_micro_addr, "ext_B") == 0) {		strcpy(BIN_micro_addr,"08");}
	if (strcmp(ASM_micro_addr, "addr_A_H") == 0) {	strcpy(BIN_micro_addr,"28");}
	if (strcmp(ASM_micro_addr, "addr_A_L") == 0) {	strcpy(BIN_micro_addr,"20");}
	if (strcmp(ASM_micro_addr, "addr_B_H") == 0) {	strcpy(BIN_micro_addr,"38");}
	if (strcmp(ASM_micro_addr, "addr_B_L") == 0) {	strcpy(BIN_micro_addr,"30");}
	if (strcmp(ASM_micro_addr, "PC_L") == 0) {		strcpy(BIN_micro_addr,"40");}
	if (strcmp(ASM_micro_addr, "PC_H") == 0) {		strcpy(BIN_micro_addr,"48");}
	if (strcmp(ASM_micro_addr, "CONFIG") == 0) {	strcpy(BIN_micro_addr,"60");}
	if (strcmp(ASM_micro_addr, "STATUS") == 0) {	strcpy(BIN_micro_addr,"68");}
	if (strcmp(ASM_micro_addr, "COUNTER") == 0) {	strcpy(BIN_micro_addr, "70");}
	
	j=sscanf(ASM_micro_addr,"CACHE_%d",&i); 
	if (j==1) {
		sprintf(BIN_micro_addr,"%X",i+128);
	}
}

void read_ALU_OP(const char* ASM_AL_8OP, char* BIN_ALU_OP) {
	int i,j,k;
	char* toto;
	if (strcmp(ASM_AL_8OP, "SUBS") == 0) {	strcpy(BIN_ALU_OP,"0");}
	if (strcmp(ASM_AL_8OP, "ADD") == 0) {	strcpy(BIN_ALU_OP,"1");}
	if (strcmp(ASM_AL_8OP, "MULT_H") == 0){	strcpy(BIN_ALU_OP,"3");}
	if (strcmp(ASM_AL_8OP, "MULT_L") == 0){	strcpy(BIN_ALU_OP,"4");}
	if (strcmp(ASM_AL_8OP, "DIV_Q") == 0) {	strcpy(BIN_ALU_OP,"5");}
	if (strcmp(ASM_AL_8OP, "DIV_R") == 0) {	strcpy(BIN_ALU_OP,"6");}
	if (strcmp(ASM_AL_8OP, "NOT") == 0) {	strcpy(BIN_ALU_OP,"7");}
	
	if (strcmp(ASM_AL_8OP, "aeb") == 0) {	strcpy(BIN_ALU_OP,"8");}
	if (strcmp(ASM_AL_8OP, "agb") == 0) {	strcpy(BIN_ALU_OP,"9");}
	if (strcmp(ASM_AL_8OP, "ageb") == 0) {	strcpy(BIN_ALU_OP,"A");}
	if (strcmp(ASM_AL_8OP, "alb") == 0) {	strcpy(BIN_ALU_OP,"B");}
	if (strcmp(ASM_AL_8OP, "aleb") == 0) {	strcpy(BIN_ALU_OP,"C");}
	if (strcmp(ASM_AL_8OP, "aneb") == 0) {	strcpy(BIN_ALU_OP,"D");}
	if (strcmp(ASM_AL_8OP, "AND") == 0) {	strcpy(BIN_ALU_OP,"E");}
	if (strcmp(ASM_AL_8OP, "OR") == 0) {	strcpy(BIN_ALU_OP,"F");}
}

void memory_address_conversion (unsigned int my_address, char* MIF_address) {
	if (my_address<=15) {		sprintf(MIF_address,"00%X",my_address);}
	else if (my_address<=255) {	sprintf(MIF_address,"0%X",my_address);}
	else {						sprintf(MIF_address,"%X",my_address);}
}

void write_memory_addr (FILE* fid, unsigned int* my_address) {
	char MIF_address[20];
	strcpy(MIF_address,"");
	if (*my_address<=15) {		sprintf(MIF_address,"00%X",*my_address);}
	else if (*my_address<=255) {	sprintf(MIF_address,"0%X",*my_address);}
	else {						sprintf(MIF_address,"%X",*my_address);}
	*my_address=*my_address+1;
	fprintf(fid,"	%s  :   ",MIF_address);
}

char ASM_input[500000];
char MIF_data[100000];
char ASM_command_tab[20000][2000];

int main(int argc, char* argv[])
{
	FILE* fid_in;
	FILE* fid_out;	
	char filename[20];
	char filename_extend[20];
	char MIF_data_temp[5000];
	char out_format_txt[2000];
	char ASM_command[5000];
	char* ASM_command_temp;
	char ASM_command_2[2000];
	char MIF_address[2000];
	char line_temp_2[5000];
	char* ASM_instr;
	char* ASM_8_16;
	char ASM_param[2000];
	char* ASM_read;
	char* ASM_immediate;
	char* ASM_comment;
	char* ASM_ALU_OP;
	char ASM_immediate_2[2000];
	char *ASM_micro_addr;
	char char_data_1, char_data_2, char_data_3, char_data_4;
	int i,j,k, nb_lignes;
	int nb_char_ASM;
	int out_format;
	int increment_data;
	int data_size,BIN_data_size;
	unsigned int my_address=0;
	unsigned int data_address=0;
	unsigned int last_address=1024;
	char BIN_micro_addr[20]; 
	char BIN_ALU_OP[20];
	int BIN_micro_instr;
	int id_line=1;
	int id_char_raw=0;
	int id_char_line=0;
	int compt_instr=0;
	printf ("\r\n** A2Z assembler 001 **\r\n");
	strcpy(filename,argv[1]);
	strcpy(out_format_txt,argv[2]);
	
	strcpy(out_format_txt,argv[2]);
	if (strcmp(out_format_txt, "MIF") == 0) {out_format=1;}
	if (strcmp(out_format_txt, "HEX") == 0) {out_format=2;}
	if (strcmp(out_format_txt, "BIN") == 0) {out_format=3;}
	strcpy (filename_extend, "");
	sprintf (filename_extend, "%s/%s.asm", filename, filename);
	fid_in=fopen (filename_extend,"r");

	strcpy(filename,argv[1]);
	strcpy (filename_extend, "");
	sprintf (filename_extend, "%s/%s.mif", filename, filename);
	fid_out=fopen (filename_extend,"w");

	if (out_format==1) {
		fprintf (fid_out, "WIDTH=16;\nDEPTH=1024;\n\nADDRESS_RADIX=HEX;\nDATA_RADIX=HEX;\n\nCONTENT BEGIN\n");
	}
	for (i=0; i<499000; i++) {
		ASM_input [i] = 0;
	}
	nb_char_ASM=fread (ASM_input, 1, 499000, fid_in);
	ASM_input[nb_char_ASM]=0;
	while(ASM_input[id_char_raw]!=NULL) {
		if ((ASM_input[id_char_raw]=='\n')){
			line_temp_2[id_char_line]=0;
			strcpy(ASM_command_tab[id_line],line_temp_2);
			id_line++;
			id_char_line=0;
		} else {
			line_temp_2[id_char_line]=ASM_input[id_char_raw];
			id_char_line++;
		}
		id_char_raw++;
	}
	line_temp_2[id_char_line]=0;
	strcpy(ASM_command_tab[id_line],line_temp_2);
	nb_lignes=id_line+1;
	
	for (i=1;i<nb_lignes;i++) {
		strcpy(ASM_command,ASM_command_tab[i]);
		if ((ASM_command[0]=='/')&&(out_format==1)) { // The line is a COMMENT
			fprintf (fid_out,"--\t%s\n", ASM_command+1);
		}
		if ( (ASM_command[0]!=0) && (ASM_command[0]!='/') && (ASM_command[0]!='\n') ) {
			ASM_instr = strtok (ASM_command,":");
			
			ASM_8_16 = strtok (NULL,":");
			sscanf(ASM_8_16,"%d",&data_size);
			if (data_size==8) {BIN_data_size=0;}
			else {BIN_data_size=1;}
			
			if (strcmp(ASM_instr, "CONS") == 0) {
				ASM_micro_addr = strtok (NULL,":");
				sscanf(ASM_micro_addr,"%x",&data_address);
				if (data_address<last_address) {last_address=data_address;}
				ASM_immediate = strtok (NULL,":");
				if (BIN_data_size==1) {
					j=0;
					strcpy (ASM_immediate_2, ASM_immediate);
					while (sscanf(ASM_immediate_2+j, "%c%c%c%c", &char_data_3, &char_data_4, &char_data_1, &char_data_2)==4) {
						memory_address_conversion(data_address,MIF_address); // WARNING : MIF addressing on 16bits!
						if (j==0) {
							sprintf(MIF_data_temp,"	%s  :   %c%c%c%c",MIF_address, char_data_1, char_data_2, char_data_3, char_data_4);
							strcat(MIF_data, MIF_data_temp);
							sprintf(MIF_data_temp,";	-- %s:%s:%s:%s\n",ASM_command,ASM_8_16,ASM_micro_addr,ASM_immediate);
							strcat(MIF_data, MIF_data_temp);
						} else {
							sprintf(MIF_data_temp,"	%s  :   %c%c%c%c;\n",MIF_address, char_data_1, char_data_2, char_data_3, char_data_4);
							strcat(MIF_data, MIF_data_temp);
						}
						data_address=data_address+1;
						j=j+4;
					}
				}
				
			}

			if (strcmp(ASM_instr, "WRITE") == 0) {
				if (out_format==1) {write_memory_addr(fid_out,&my_address);}
				BIN_micro_instr=8;
				ASM_micro_addr = strtok (NULL,":");
				read_micro_address(ASM_micro_addr,BIN_micro_addr);
				ASM_immediate = strtok (NULL,";"); 
				ASM_comment = strtok (NULL,";"); 
				strcpy(ASM_immediate_2,ASM_immediate);
				
				fprintf(fid_out,"%X0%s",BIN_micro_instr+BIN_data_size,BIN_micro_addr);
				if (out_format==1) {
					fprintf (fid_out,";	-- %s:%s:%s:%s",ASM_command,ASM_8_16,ASM_micro_addr,ASM_immediate);
					if (ASM_comment!= NULL) {fprintf (fid_out,";	%s",ASM_comment);};
					fprintf (fid_out,"\n");
				}
				else if (out_format==2) {fprintf (fid_out,"\n");}
				if (out_format==1) {write_memory_addr(fid_out,&my_address);}
				if (out_format==1) {fprintf (fid_out,"%s;\n",ASM_immediate);}
				else if (out_format==2) {fprintf (fid_out,"%s\n",ASM_immediate);}
			} 
			else if (strcmp(ASM_instr, "MOVE_C_TO") == 0) {
				if (out_format==1) {write_memory_addr(fid_out,&my_address);}
				BIN_micro_instr=10;
				ASM_micro_addr = strtok (NULL,";");
				ASM_comment = strtok (NULL,";"); 
				read_micro_address(ASM_micro_addr,BIN_micro_addr);
				fprintf(fid_out,"%X0%s",BIN_micro_instr+BIN_data_size,BIN_micro_addr);
				if (out_format==1) {
					fprintf (fid_out,";	-- %s:%s:%s",ASM_command,ASM_8_16,ASM_micro_addr);
					if (ASM_comment!= NULL) {fprintf (fid_out,";	%s",ASM_comment);};
					fprintf (fid_out,"\n");
				}
				else if (out_format==2) {fprintf (fid_out,"\n");}
			}
			else if (strcmp(ASM_instr, "COND_WRITE") == 0) {
				if (out_format==1) {write_memory_addr(fid_out,&my_address);}
				BIN_micro_instr=12;
				ASM_micro_addr = strtok (NULL,":");
				read_micro_address(ASM_micro_addr,BIN_micro_addr);
				ASM_immediate = strtok (NULL,";"); 
				ASM_comment = strtok (NULL,";"); 
				strcpy(ASM_immediate_2,ASM_immediate);
				
				fprintf(fid_out,"%X0%s",BIN_micro_instr+BIN_data_size,BIN_micro_addr);
				if (out_format==1) {
					fprintf (fid_out,";	-- %s:%s:%s:%s",ASM_command,ASM_8_16,ASM_micro_addr,ASM_immediate);
					if (ASM_comment!= NULL) {fprintf (fid_out,";	%s",ASM_comment);};
					fprintf (fid_out,"\n");
				}
				else if (out_format==2) {fprintf (fid_out,"\n");}
				if (out_format==1) {write_memory_addr(fid_out,&my_address);}
				if (out_format==1) {fprintf (fid_out,"%s;\n",ASM_immediate);}
				else if (out_format==2) {fprintf (fid_out,"%s\n",ASM_immediate);}
			}
			else if (strcmp(ASM_instr, "COND_MOVE_C_TO") == 0) {
				if (out_format==1) {write_memory_addr(fid_out,&my_address);}
				BIN_micro_instr=14;
				ASM_micro_addr = strtok (NULL,";");
				ASM_comment = strtok (NULL,";"); 
				read_micro_address(ASM_micro_addr,BIN_micro_addr);
				fprintf(fid_out,"%X0%s",BIN_micro_instr+BIN_data_size,BIN_micro_addr);
				if (out_format==1) {
					fprintf (fid_out,";	-- %s:%s:%s",ASM_command,ASM_8_16,ASM_micro_addr);
					if (ASM_comment!= NULL) {fprintf (fid_out,";	%s",ASM_comment);};
					fprintf (fid_out,"\n");
				}
				else if (out_format==2) {fprintf (fid_out,"\n");}
			}
			else if (strcmp(ASM_instr, "MOVE_TO_C") == 0) {
				if (out_format==1) {write_memory_addr(fid_out,&my_address);}
				BIN_micro_instr=0;
				ASM_micro_addr = strtok (NULL,";");
				ASM_comment = strtok (NULL,";"); 
				read_micro_address(ASM_micro_addr,BIN_micro_addr);
				fprintf(fid_out,"%X0%s",BIN_micro_instr+BIN_data_size,BIN_micro_addr);
				if (out_format==1) {
					fprintf (fid_out,";	-- %s:%s:%s",ASM_command,ASM_8_16,ASM_micro_addr);
					if (ASM_comment!= NULL) {fprintf (fid_out,";	%s",ASM_comment);};
					fprintf (fid_out,"\n");
				}
				else if (out_format==2) {fprintf (fid_out,"\n");}
			}
			else if (strcmp(ASM_instr, "MOVE_TO_B") == 0) {
				if (out_format==1) {write_memory_addr(fid_out,&my_address);}
				BIN_micro_instr=2;
				ASM_micro_addr = strtok (NULL,";");
				ASM_comment = strtok (NULL,";"); 
				read_micro_address(ASM_micro_addr,BIN_micro_addr);
				fprintf(fid_out,"%X0%s",BIN_micro_instr+BIN_data_size,BIN_micro_addr);
				if (out_format==1) {
					fprintf (fid_out,";	-- %s:%s:%s",ASM_command,ASM_8_16,ASM_micro_addr);
					if (ASM_comment!= NULL) {fprintf (fid_out,";	%s",ASM_comment);};
					fprintf (fid_out,"\n");
				}
				else if (out_format==2) {fprintf (fid_out,"\n");}
			}
			else if (strcmp(ASM_instr, "ALU") == 0) { // pas fini
				if (out_format==1) {write_memory_addr(fid_out,&my_address);}
				BIN_micro_instr=4;
				ASM_ALU_OP= strtok (NULL,":");
				read_ALU_OP(ASM_ALU_OP,BIN_ALU_OP);
				ASM_micro_addr = strtok (NULL,";");
				ASM_comment = strtok (NULL,";"); 
				read_micro_address(ASM_micro_addr,BIN_micro_addr);
				fprintf(fid_out,"%X%s%s", BIN_micro_instr+ BIN_data_size, BIN_ALU_OP, BIN_micro_addr);
				if (out_format==1) {
					fprintf (fid_out,";	-- %s:%s:%s:%s",ASM_command,ASM_8_16,ASM_ALU_OP,ASM_micro_addr);
					if (ASM_comment!= NULL) {fprintf (fid_out,";	%s",ASM_comment);};
					fprintf (fid_out,"\n");
				}
				else if (out_format==2) {fprintf (fid_out,"\n");}
			}
			else if (strcmp(ASM_instr, "ALU_CONS") == 0) { // pas fini
				if (out_format==1) {write_memory_addr(fid_out,&my_address);}
				BIN_micro_instr=6;
				ASM_ALU_OP= strtok (NULL,":");
				read_ALU_OP(ASM_ALU_OP,BIN_ALU_OP);
				ASM_micro_addr = strtok (NULL,":");
				read_micro_address(ASM_micro_addr,BIN_micro_addr);
				ASM_immediate = strtok (NULL,";"); 
				ASM_comment = strtok (NULL,";"); 
				strcpy(ASM_immediate_2,ASM_immediate);
				fprintf(fid_out,"%X%s%s", BIN_micro_instr+ BIN_data_size, BIN_ALU_OP, BIN_micro_addr);
				if (out_format==1) {
					fprintf (fid_out,";	-- %s:%s:%s:%s:%s",ASM_command,ASM_8_16,ASM_ALU_OP,ASM_micro_addr, ASM_immediate);
					if (ASM_comment!= NULL) {fprintf (fid_out,";	%s",ASM_comment);};
					fprintf (fid_out,"\n");
				}
				else if (out_format==2) {fprintf (fid_out,"\n");}
				if (out_format==1) {write_memory_addr(fid_out,&my_address);}
				if (out_format==1) {fprintf (fid_out,"%s;\n",ASM_immediate);}
				else if (out_format==2) {fprintf (fid_out,"%s\n",ASM_immediate);}
			}

		}
	}
	
	if (out_format==1) {
		memory_address_conversion(my_address,MIF_address);
		fprintf(fid_out,"	[%s..",MIF_address);
		memory_address_conversion(last_address-1,MIF_address);
		fprintf(fid_out,"%s]  :   0000;\n",MIF_address);
		fprintf(fid_out,"%s",MIF_data);
		fprintf(fid_out,"END;\n");
	}
	fclose (fid_in);
	fclose (fid_out);
	printf("Assembler : success\r\n\r\n");
	return 0;
}

