// compiler_A2Z_001.cpp: 

#include "stdafx.h"
#include "stdio.h"
#include "string.h"
#include "ctype.h"
#include <stdlib.h>

#define object_addr_H_offset 0

#define offset_cache_express 10

typedef enum type_line type_line;
enum type_line
{
    nothing, instruction, directive, comment, object, subf, include, label, macro, define, appli_config
};
type_line line_type[5000];

typedef enum type_object type_object;
enum type_object
{
    charact, integer, pointer, cache
};

struct object_details {
	type_object object_type;
	int line_source;
	char label[20];
	int size_1;
	int size_2;
	int size_tot;
	int type_cons;
	int type_cache;
	int function_id;
	unsigned int addr_H;
	unsigned int addr_L;
};

object_details object_list[5000];

int var_max_size=0;
int code_max_size=0;
int var_addr_offset_out=0;
int code_var_separation=0;

char basic_lines[5000][2000];
char basic_lines_indent[5000][2000];
int basic_lines_function [5000];

char functions_name[500][100];	//
int functions_type[500];		// 1=subf 2=ASMf 3=macro
int functions_in_count[500];
int functions_out_count[500];
char functions_input[500][20][20]; // list of input variables of each function
char functions_output[500][20][20];// list of output variables of each function
int functions_basic_begin[500]; // Basic code beginning of the function (for marker)
int nb_functions;
unsigned int offset_H;
unsigned int tot_bin_size;

char text_const_ASM[500000]; // constants declaration
int i_cache_express;
int nb_objects;

int ASM_pos_begin [5000]; // for each basic line, ASM begin pos
int ASM_pos_midfor [5000]; // for each basic line, ASM midfor
int ASM_pos_end [5000]; // for each basic line, ASM end pos
int ASM_pos_abs;

int accolade_depth;
int accolade_temp_input[2000];
int accolade_temp_type[2000];
int accolade_temp_index[2000];

int accolade_index; 
int accolade_type_glob[5000]; 
int accolade_basic_begin[5000]; 
int accolade_basic_end[5000]; 
char accolade_next_content[5000][100];

int parse_expression (char* input_string, char* ASM_string, char BC_dest, int *expr_type, int line_nb, int function_id);

int parse_instruction (char* input_string, char* ASM_string, int line_nb, int function_id);

void dec_to_hex (int input_dec, char* char_out) {
	if (input_dec<=15) {		sprintf(char_out,"000%X",input_dec);}
	else if (input_dec<=255) {	sprintf(char_out,"00%X",input_dec);}
	else if (input_dec<=4095) {	sprintf(char_out,"0%X",input_dec);}
	else {						sprintf(char_out,"%X",input_dec);}
}

void dec_to_hex_littleendian(int input_dec, char* char_out) {
	char temp_s[10];
	if (input_dec <= 15) { sprintf(temp_s, "000%X", input_dec); }
	else if (input_dec <= 255) { sprintf(temp_s, "00%X", input_dec); }
	else if (input_dec <= 4095) { sprintf(temp_s, "0%X", input_dec); }
	else { sprintf(temp_s, "%X", input_dec); }
	sprintf(char_out, "%c%c%c%c", temp_s[2], temp_s[3], temp_s[0], temp_s[1]);
}

void interpret_directive(int line_id) {
	char line_2[2000];
	char *type_direct;
	line_type[line_id] = nothing;
	strcpy(line_2, basic_lines[line_id]);
	type_direct=strtok(line_2, " (");
	if (strcmp(type_direct, "#char") == 0) {	line_type[line_id] = object;}
	if (strcmp(type_direct, "#int") == 0) {		line_type[line_id] = object;}
	if (strcmp(type_direct, "#pointer") == 0) {	line_type[line_id] = object;}
	if (strcmp(type_direct, "#const") == 0) {	line_type[line_id] = object;}
	if (strcmp(type_direct, "#CACHE") == 0) {	line_type[line_id] = object;}
	if (strcmp(type_direct, "#subf") == 0) {	line_type[line_id] = subf;	}
	if (strcmp(type_direct, "#ASMf") == 0) {	line_type[line_id] = subf;	}
	if (strcmp(type_direct, "#macro") == 0) {	line_type[line_id] = subf;	}
	if (strcmp(type_direct, "#label") == 0) {	line_type[line_id] = label;	}
	if (strcmp(type_direct, "#include") == 0) {	line_type[line_id] = include;}
	if (strcmp(type_direct, "#define") == 0) {	line_type[line_id] = define;}
	if (strcmp(type_direct, "#appli_config") == 0) {	line_type[line_id] = appli_config;}
	

	if (line_type[line_id] == nothing) {
		printf ("ERROR unknown directive, line %d\r\n", line_id);
		exit (EXIT_FAILURE);
	}
}

char BASIC_raw[200000];
int read_basic_file(char* filename) {
	char filename_extend[40];
	char *line_temp_1;
	char line_temp_2[2000];
	int id_line=1;
	int nb_chars=0;
	int id_char_raw=0;
	int id_char_line=0;
	int nb_lines;
	int begin_line;

	FILE* fid_in;
	
	strcpy (filename_extend, filename);
	strcat(filename_extend,".bas");
	fid_in=fopen (filename_extend,"r");
	nb_chars=fread (BASIC_raw, 1, 199000, fid_in);
	fclose (fid_in);
	BASIC_raw[nb_chars] = 0;
	
	while(BASIC_raw[id_char_raw]!=NULL) {
		if ((BASIC_raw[id_char_raw]=='\n')){
			line_temp_2[id_char_line]=0;
			begin_line=0;
			while ((line_temp_2[begin_line]==' ')||(line_temp_2[begin_line]=='\t')) {
				begin_line++;
			}
			strcpy(basic_lines[id_line],line_temp_2+begin_line);
			strcpy(basic_lines_indent[id_line], line_temp_2);
			id_line++;
			id_char_line=0;
		} else {
			line_temp_2[id_char_line]=BASIC_raw[id_char_raw];
			id_char_line++;
		}
		id_char_raw++; //
	}
	line_temp_2[id_char_line]=0;
	begin_line=0;
	while ((line_temp_2[begin_line]==' ')||(line_temp_2[begin_line]=='\t')) {
		begin_line++;
	}
	strcpy(basic_lines[id_line],line_temp_2+begin_line);
	strcpy(basic_lines_indent[id_line], line_temp_2);
	
	nb_lines=id_line;
	for (id_line=1;id_line<=nb_lines; id_line++) { //first pass 
		line_type[id_line]=instruction;
		if (basic_lines[id_line][0]=='#') {
			line_type[id_line]=directive;
			interpret_directive(id_line);
		}
		if (basic_lines[id_line][0]=='/') {line_type[id_line] = comment;}
		if (basic_lines[id_line][0]==0) {line_type[id_line] = comment;}
		if ( (isalpha (basic_lines[id_line][0])) || (basic_lines[id_line][0]=='}') ) {	line_type[id_line] = instruction;	}
	}
	return nb_lines;
}

void write_conf_file(char* filename) {
	char filename_extend[50];
	FILE* fid_out;
	sprintf(filename_extend, "%s/%s.conf", filename, filename);
	fid_out = fopen(filename_extend, "w");
	fprintf(fid_out, "%x %d\n", offset_H, tot_bin_size);
	fclose(fid_out);
}

void write_ASM_file (char* filename, char* ASM_out) {
	char filename_extend[50];
	FILE* fid_out;
	sprintf (filename_extend, "%s/%s.asm", filename, filename);
	fid_out=fopen (filename_extend,"w");
	fprintf (fid_out, "%s", ASM_out);
	fclose (fid_out);
}

void write_obj_file (char* filename) {
	char filename_extend[50];
	FILE* fid_out;
	char text_temp[20];
	int i;
	sprintf (filename_extend, "%s/%s.obj", filename, filename);
	fid_out=fopen (filename_extend,"w");
	fprintf (fid_out, "\t** FUNCTIONS **\n");
	for (i=1; i<=nb_functions; i++) {
		if (functions_type[i]==1) {strcpy (text_temp, "subf");}
		if (functions_type[i]==2) {strcpy (text_temp, "ASMf");}
		if (functions_type[i]==3) {strcpy (text_temp, "macro");}
		fprintf (fid_out, "L%d\t%s\t%s\n", functions_basic_begin[i], functions_name[i], text_temp);
	}
	fprintf (fid_out, "\n\t** VARIABLES ** \n");
	for (i=0; i<=nb_objects; i++) {
		fprintf (fid_out, "L%d\t%s\t", object_list[i].line_source, object_list[i].label);
		if (object_list[i].object_type==charact) {strcpy (text_temp, "char");}
		if (object_list[i].object_type==integer) {strcpy (text_temp, "int");}
		fprintf (fid_out, "%s\tsize 1:%d\tsize 2:%d\t", text_temp, object_list[i].size_1, object_list[i].size_2);
		dec_to_hex (object_list[i].addr_L, text_temp);
		fprintf (fid_out, "addr8:%s ", text_temp);
		dec_to_hex (object_list[i].addr_L/2, text_temp);
		fprintf (fid_out, "addr16:%s\n", text_temp);
	}
	fclose (fid_out);
}

void declare_objects (int nb_lines) {
	char line_2[2000];
	char end_line[2000];
	char *type_direct;
	char *type_constant;
	char *raw_label;

	int id_line;
	int unit_size;
	char * first_size;
	char *second_size;
	int id_object;
	int loc_funct_id;
	int loc_funct_type;
	int i;
	
	id_object=0;
	for (id_line=1; id_line<=nb_lines; id_line++) {
		if (line_type[id_line]==object) {
			object_list[id_object].line_source=id_line;
			object_list[id_object].function_id = basic_lines_function [id_line]; //function id
			loc_funct_id = basic_lines_function [id_line];
			loc_funct_type = functions_type [loc_funct_id];
			if (loc_funct_type == 3) {
				printf ("ERROR cannot declare variable inside a macro, line %d\r\n", id_line);
				exit (EXIT_FAILURE);
			}
			strcpy(line_2, basic_lines[id_line]);
			type_direct=strtok(line_2, " ");
			object_list[id_object].type_cons = 0;
			object_list[id_object].size_1 = 1;
			object_list[id_object].size_2 = 1;
			if (strcmp(type_direct, "#char") == 0) {	object_list[id_object].object_type = charact;}
			if (strcmp(type_direct, "#int") == 0) {		object_list[id_object].object_type = integer;}
			if (strcmp(type_direct, "#pointer") == 0) {	object_list[id_object].object_type = pointer;}
			if (strcmp(type_direct, "#CACHE") == 0) {	object_list[id_object].object_type = cache;}
			if (strcmp(type_direct, "#const") == 0) {
				object_list[id_object].type_cons = 1;
				type_constant =strtok(NULL, " ");
				if (strcmp(type_constant, "char") == 0) { object_list[id_object].object_type = charact; }
				if (strcmp(type_constant, "int") == 0) { object_list[id_object].object_type = integer; }
				if (strcmp(type_constant, "pointer") == 0) { object_list[id_object].object_type = pointer; }
			}

			raw_label = strtok(NULL, " [");
			strcpy(object_list[id_object].label, raw_label); // LABEL
			for (i=0; i<id_object; i++) { // check if double declaration
				if ((strcmp(object_list[i].label, raw_label) == 0) && (object_list[i].function_id == object_list[id_object].function_id)) {
					printf("ERROR variable '%s' already declared, line %d\r\n", raw_label, id_line);
					exit (EXIT_FAILURE);
				}
				if ((strcmp(object_list[i].label, raw_label) == 0) && ((object_list[i].function_id == 0) || (object_list[id_object].function_id == 0))) {
					printf("ERROR variable '%s' already declared, line %d\r\n", raw_label, id_line);
					exit (EXIT_FAILURE);
				}
			}
			strcpy(line_2, basic_lines[id_line]);		// SIZE 1 and 2
			first_size = strchr (line_2, '[');
			if (first_size!=NULL) {
				sscanf(first_size," [%d",&object_list[id_object].size_1);
				second_size=strchr(first_size+1,'['); // look for second bracket
				if (second_size!=NULL) {
					sscanf(second_size," [%d",&object_list[id_object].size_2);
				}
			}
			if (object_list[id_object].object_type == charact) {unit_size=1;} //size_tot
			if (object_list[id_object].object_type == integer) {unit_size=2;}
			if (object_list[id_object].object_type == pointer) {unit_size=4;}
			if (object_list[id_object].object_type == cache) {	unit_size=0;}
			object_list[id_object].size_tot = unit_size * object_list[id_object].size_1 * object_list[id_object].size_2;
			
			id_object++;
		}
	}
	nb_objects=id_object-1;
}

char convert_UTF8_C2[300] = { 173, 32, 156, 207, 32, 32, 245, 249, 184, 32, 174, 32, 32, 169, 32, 248, 241, 253, 252, 32, 230, 32, 250, 32, 32, 32, 175, 172, 171, 243 };
char convert_UTF8_C3[300] = { 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 133, 32, 131, 32, 32, 32, 32, 135, 138, 130, 136, 137, 32, 32, 140, 139, 32, 32, 32, 32, 147, 32, 32, 32, 32, 151, 32, 150, 129, 32, 32, 32};
int allocate_objects(void) {
	int id_object;
	int id_char_out;
	int id_line_loc;
	int loc_funct_id;
	int adress_object_loc; 
	unsigned int pair_address;
	unsigned int const_objects_addr_L;
	char line_2[2000];
	char text_temp[2000];
	char text_temp2[2000];
	char ASM_init[50000];
	char* begin_txt_const;
	unsigned char read_char; 
	unsigned char read_char_2;
	int taille_const;
	int i;
	
	adress_object_loc = var_max_size - 1;
	for (id_object=0; id_object<=nb_objects; id_object++) { // search for CONST (put at the end of file)
		if ( (object_list[id_object].type_cons==1) && (object_list[id_object].object_type!=cache) ) {
			adress_object_loc = adress_object_loc - object_list[id_object].size_tot;
			pair_address=adress_object_loc/2;
			adress_object_loc = pair_address * 2;

			object_list[id_object].addr_H = object_addr_H_offset;
			object_list[id_object].addr_L = adress_object_loc;
		}
	}
	const_objects_addr_L=adress_object_loc;
	for (id_object=0; id_object<=nb_objects; id_object++) { // search for non CONST (put in the folowing)
		if ( (object_list[id_object].type_cons==0) && (object_list[id_object].object_type!=cache) ) {
			adress_object_loc = adress_object_loc - object_list[id_object].size_tot;
			pair_address=adress_object_loc/2;
			adress_object_loc = pair_address * 2;
			object_list[id_object].addr_H = object_addr_H_offset;
			object_list[id_object].addr_L = adress_object_loc;
		}
	}
	if (adress_object_loc <=0) {
		printf ("\r\nERROR, allocation of var impossible : too big \r\n");
		exit (EXIT_FAILURE);
	}
	// CACHE
	int cache_index[500];
	for (i=0; i<=500; i++) {
		cache_index[i] = 50;
	}
	for (id_object=0; id_object<=nb_objects; id_object++) { // search for non CONST (put in the folowing)
		if ( object_list[id_object].object_type==cache ) {
			id_line_loc = object_list[id_object].line_source; 
			loc_funct_id = basic_lines_function [id_line_loc];
			object_list[id_object].addr_L = cache_index[loc_funct_id];
			cache_index[loc_funct_id] ++;
		}
	}

	// constant initialization
	strcpy (text_const_ASM, "/ CONSTANT INITIALIZATION\n");
	//printf("TOTO\r\n");
	int const_init_type=0;
	int unit_size;
	int init_size=0;
	int init_value=0;
	int local_abs_addr;
	char* char_point; 
	for (id_object=nb_objects; id_object>=0; id_object--) { // reverse because of decreasing address
		if (object_list[id_object].type_cons==1) {
			id_line_loc = object_list[id_object].line_source;
			strcpy(line_2, basic_lines[id_line_loc]);
			if (object_list[id_object].object_type==charact) { unit_size=1;} //size_tot
			if (object_list[id_object].object_type==integer) { unit_size=2;}
			begin_txt_const=strstr(line_2, "=");
			if (begin_txt_const==0) {
				printf ("ERROR missing const initialization, line %d\r\n", id_line_loc);
				exit (EXIT_FAILURE);
			}
			while (begin_txt_const[1] == ' ') { //delete useless spaces
				begin_txt_const = begin_txt_const + 1;
			}
			// first : detection of const initialization type 1:char 2:dec 3:hex
			const_init_type = 0;
			init_size = 0;
			if (begin_txt_const[1]=='"') {const_init_type = 1; begin_txt_const=begin_txt_const+2;}
			else if (begin_txt_const[1]=='x') {const_init_type = 3; begin_txt_const=begin_txt_const+2;}
			else if ( isdigit(begin_txt_const[1]) ) {const_init_type = 2; begin_txt_const=begin_txt_const+1;}

			if (const_init_type == 0) {
				printf ("ERROR bad const initialization, line %d\r\n", id_line_loc);
				exit (EXIT_FAILURE);
			}
			if ( (const_init_type==1) && (unit_size==2) ) {
				printf ("ERROR cannot initialize int with text, line %d\r\n", id_line_loc);
				exit (EXIT_FAILURE);
			}

			// begin parsing 
			strcpy (ASM_init, "");
			while ( (begin_txt_const[0]!=0) && (begin_txt_const[0]!='"') )  {
				if (const_init_type==1) {// text char
					sscanf (begin_txt_const, "%c", &read_char);
					sscanf (begin_txt_const+1, "%c", &read_char_2);
					begin_txt_const++;
					if ( (read_char=='\\') && (read_char_2=='n') ) { //special case for \n
						begin_txt_const++;
						strcat (ASM_init, "0A");
					} else if ( (read_char=='\\') && (read_char_2=='"') ){
						begin_txt_const++;
						strcat (ASM_init, "22");
					} else {
						if (read_char == 0xC2) {
							read_char = convert_UTF8_C2[read_char_2-0xA1];
							begin_txt_const++;
						}
						if (read_char == 0xC3) {
							read_char = convert_UTF8_C3[read_char_2-0x80];
							begin_txt_const++;
						}
						if (read_char<=15) {sprintf(text_temp, "0%X", read_char);}
						else {				sprintf(text_temp, "%X", read_char);}
						strcat (ASM_init, text_temp);
					}
				}
				if ( (const_init_type==3) && (unit_size==1) ) {
					sscanf (begin_txt_const, "%c%c", &text_temp[0], &text_temp[1]);
					text_temp[2]=0;
					begin_txt_const = begin_txt_const + 2; 
					strcat (ASM_init, text_temp);
				}
				if ( (const_init_type==3) && (unit_size==2) ) {
					sscanf (begin_txt_const, "%c%c%c%c", &text_temp[0], &text_temp[1], &text_temp[2], &text_temp[3]);
					text_temp[4]=0;
					begin_txt_const = begin_txt_const + 4; 
					strcat (ASM_init, text_temp);
				}
				if ( (const_init_type==2) && (unit_size==1) ) {
					sscanf (begin_txt_const, "%d", &init_value);
					if (init_value<=15) {sprintf(text_temp, "0%X", init_value);}
					else {				sprintf(text_temp, "%X", init_value);}
					strcat (ASM_init, text_temp);
					char_point = strchr (begin_txt_const, ',');
					if (char_point == 0) {begin_txt_const[0]=0;}
					else {begin_txt_const = char_point+1;}
				}
				if ( (const_init_type==2) && (unit_size==2) ) {
					sscanf (begin_txt_const, "%d", &init_value);
					dec_to_hex_littleendian(init_value, text_temp);
					strcat (ASM_init, text_temp);
					char_point = strchr (begin_txt_const, ',');
					if (char_point == 0) {begin_txt_const[0]=0;}
					else {begin_txt_const = char_point+1;}
				}
				init_size = init_size + unit_size;
				if (init_size > object_list[id_object].size_tot ) {
					printf ("ERROR init too long for size, line %d\r\n", id_line_loc);
					exit (EXIT_FAILURE);
				}

			}

			for (i=init_size; i<object_list[id_object].size_tot; i++) {
				strcat(ASM_init, "00");
			}
			local_abs_addr = (object_list[id_object].addr_L + var_addr_offset_out)/ 2 ;
			dec_to_hex (local_abs_addr, text_temp2);
			sprintf (text_temp, "/%d %s \t%s\n", id_line_loc, text_temp2, basic_lines_indent[id_line_loc]);
			strcat (text_const_ASM, text_temp); 
			strcat (text_const_ASM, "CONS:16:");
			strcat (text_const_ASM, text_temp2);
			strcat (text_const_ASM, ":");
			strcat (text_const_ASM, ASM_init);
			strcat (text_const_ASM, "\n");
		}
	}

	return var_max_size + 2 - adress_object_loc; //size of total var allocation in bytes
}

void delete_spaces(char* input_string, char* output_string) {
	int i=0;
	int j=0;
	while (input_string[i]!=NULL) {
		if ((input_string[i]==' ')||(input_string[i]=='\t')) {
			i++;
		} else {
			output_string[j]=input_string[i];
			i++;
			j++;
		}
	}
	output_string[j]=0;
}

int check_parenthesis_coherence(char* input_string) {
	int coherence_error=0;
	int i=0;
	int parenth_count=0;
	int bracket_count=0;
	int total_count=0;
	int last_open[20]; // 0:none 1:parenthesis 2:bracket
	while (input_string[i]!=NULL) {
		if (input_string[i]=='(') {
			parenth_count++;
			total_count++;
			last_open[total_count]=1;
		}
		if (input_string[i]=='[') {
			bracket_count++;
			total_count++;
			last_open[total_count]=2;
		}
		if (input_string[i]==')') {
			if (last_open[total_count]!=1) {coherence_error=1;}
			if (parenth_count<=0) {coherence_error=1;}
			else {
				parenth_count--;
				total_count--;
			}
		}
		if (input_string[i]==']') {
			if (last_open[total_count]!=2) {coherence_error=1;}
			if (bracket_count<=0) {coherence_error=1;}
			else {
				bracket_count--;
				total_count--;
			}
		}
		i++;
	}
	if (parenth_count!=0) {coherence_error=1;}
	if (bracket_count!=0) {coherence_error=1;}
	return coherence_error;
}

char* delete_ext_parenthesis(char* input_string){
	int i=0;
	char* out_string;
	out_string=input_string;
	while (input_string[i]!=NULL) {i++;} //string count
	if ((input_string[0]=='(')&&(input_string[i-1]==')')) {
		input_string[i-1]=0;
		out_string=input_string+1;
	}
	return out_string;
}

void ignore_internal_parenthesis (char* input_string) {
	int parenth_count=0;
	int i=0;
	while (input_string[i]!=NULL) {
		if ((input_string[i]=='(')||(input_string[i]=='[')) {parenth_count++;}
		if ((input_string[i]==')')||(input_string[i]==']')) {
			parenth_count--;
			input_string[i]=' ';
		}
		if (parenth_count>0) {input_string[i]=' ';}
		i++;
	}
}

void get_internal_parenthesis (char* input_string, char* output_string) {
	int i=0;
	int j=0;
	int index_parenthesis=0;
	while (input_string[i]!=NULL) {
		if (input_string[i] == ')') {index_parenthesis--;}
		if (index_parenthesis > 0) {
			output_string[j] = input_string[i];
			j++;
		}
		if (input_string[i] == '(') {index_parenthesis++;}
		i++;
	}
	output_string[j]=0;
}

void manage_openning_accolade (int line_nb, int accolade_type) {
	accolade_index++;
	accolade_basic_begin[accolade_index] = line_nb;
	accolade_type_glob[accolade_index] = accolade_type;
	
	accolade_depth++;
	accolade_temp_input[accolade_depth] = line_nb; 
	accolade_temp_type[accolade_depth] = accolade_type;
	accolade_temp_index[accolade_depth] = accolade_index;
}

int manage_closing_accolade (int line_nb) {
	int local_index;
	int local_type;
	if (accolade_depth < 1) {
		printf ("ERROR unexpected '}' line %d\r\n", line_nb);
		exit (EXIT_FAILURE);
	}
	local_index = accolade_temp_index[accolade_depth];
	accolade_basic_end[local_index] = line_nb;
	local_type = accolade_type_glob[local_index];
	accolade_depth--;
	return local_index;
}

char check_ALU_op(char* input_string, char* ASM_OP, int* op_position, int* op_size) {
	int i=0;
	char local_op=0;
	*op_size=1;
	while ((input_string[i]!=NULL)&&(local_op==0)) {
		// one char operations
		if (input_string[i]=='+') {local_op='+'; strcpy(ASM_OP, "ADD");}
		if (input_string[i]=='-') {local_op='-'; strcpy(ASM_OP, "SUBS");}
		if (input_string[i]=='/') {local_op='/'; strcpy(ASM_OP, "DIV_Q");}
		if (input_string[i]=='*') {local_op='*'; strcpy(ASM_OP, "MULT_L");} //mult_l
		if (input_string[i]=='&') {local_op='&'; strcpy(ASM_OP, "AND");}
		if (input_string[i]=='|') {local_op='|'; strcpy(ASM_OP, "OR");}
		if (input_string[i]=='!') {local_op='!'; strcpy(ASM_OP, "NOT");}
		if (input_string[i]=='>') {local_op='>'; strcpy(ASM_OP, "agb");}
		if (input_string[i]=='<') {local_op='<'; strcpy(ASM_OP, "alb");}
		// TWO chars operations
		if ((input_string[i]=='=')&&(input_string[i+1]=='=')) { 
			*op_size=2; local_op='='; strcpy(ASM_OP, "aeb");}
		if ((input_string[i]=='!')&&(input_string[i+1]=='=')) {
			*op_size=2; local_op='d'; strcpy(ASM_OP, "aneb");} //different from
		if ((input_string[i]=='>')&&(input_string[i+1]=='=')) {
			*op_size=2; local_op='s'; strcpy(ASM_OP, "ageb");} //superior or equal 
		if ((input_string[i]=='<')&&(input_string[i+1]=='=')) {
			*op_size=2; local_op='l'; strcpy(ASM_OP, "aleb");} //lower or equal
		if ((input_string[i]=='*')&&(input_string[i+1]=='*')) { 
			*op_size=2; local_op='m'; strcpy(ASM_OP, "MULT_H");} //mult_H
		if ((input_string[i]=='/')&&(input_string[i+1]=='/')) { 
			*op_size=2; local_op='r'; strcpy(ASM_OP, "DIV_R");} //division remainder
		i++;
	}
	*op_position=i-1;
	return local_op;
}

void split_sub_expressions(char* str_input, char* str_out_1, char* str_out_2, char local_op, int op_position, int op_size) {
	int i=0;
	int j=0;
	if (local_op=='!') {
		i=op_position+1;
		while (str_input[i]!=NULL) {
			str_out_1[j]=str_input[i];
			i++;
			j++;
		}
		str_out_1[j]=0;
	}
	if ((local_op!='!')&&(local_op!=0)) {
		for (i=0; i<op_position; i++) {
			str_out_1[i]=str_input[i];
		}
		str_out_1[op_position]=0;
		i=op_position+op_size;
		while (str_input[i]!=NULL) {
			str_out_2[j]=str_input[i];
			i++;
			j++;
		}
		str_out_2[j]=0;
	}
}

int lookfor_variable (char* input_string, int function_id, int line_nb, char AB_port, char* ASM_string_1, char* ASM_string_2) {
	int local_code_size;
	int total_code_size;
	int id_object;
	int i=0;
	int j=0;
	int expr_type_A;
	int loc_obj_size;

	int open_bracket_pos;
	int nb_bracket=-1;
	char object_label[100];
	char local_bas[100];
	char between_brackets_1[1000];
	char between_brackets_2[1000];
	char ASM_temp[2000];
	char ASM_addr_L[20];
	int is_table=1;
	while ((isalnum(input_string[i]))||(input_string[i]=='_')){
		object_label[i]=input_string[i];
		i++;
	}
	object_label[i]=0;
	open_bracket_pos=i;
	if (input_string[open_bracket_pos]==0) {nb_bracket=0;}
	else if (input_string[open_bracket_pos]=='[') {
		i=open_bracket_pos+1;
		j=0;
		while (input_string[i]!=']'){ // WARNING not robust to multiple imbricated brackets
			between_brackets_1[j]=input_string[i];
			i++;
			j++;
		}
		between_brackets_1[j]=0;
		open_bracket_pos=i+1;
		if (input_string[open_bracket_pos]==0) {nb_bracket=1;}
		else if (input_string[open_bracket_pos]=='[') {
			nb_bracket=2;
			i=open_bracket_pos+1;
			j=0;
			while (input_string[i]!=']'){ // WARNING not robust to multiple imbricated brackets
				between_brackets_2[j]=input_string[i];
				i++;
				j++;
			}
			between_brackets_2[j]=0;
		}
	}
	//printf("NB Brackets: %d\r\n", nb_bracket);

	id_object=-1;
	for (i=0; i<=nb_objects; i++) { 
		if ((strcmp(object_label, object_list[i].label)==0)&&(function_id==object_list[i].function_id)) {
			id_object=i;
		}
		if ((strcmp(object_label, object_list[i].label)==0)&&(object_list[i].function_id == 0)&&(AB_port!='F')) { 
			id_object=i; // special case for GLOBAL objects (function=0), except if AB_port = F (input or output of function)
		}
	}

	if (id_object==-1) {
		printf("ERROR unknown var '%s' line %d input %s\r\n", object_label, line_nb, input_string);
		exit (EXIT_FAILURE);
	} else {
		if (object_list[id_object].object_type == charact) {
			loc_obj_size=8;
		} else {
			loc_obj_size=16;
		}
		is_table = object_list[id_object].size_1 * object_list[id_object].size_2; //>1 if table
		if ( (nb_bracket==0) && (is_table == 1) ) { 
			total_code_size=2; //3
			dec_to_hex (object_list[id_object].addr_L, ASM_addr_L);
			sprintf(ASM_temp, "WRITE:16:addr_%c_L:%s\n", AB_port, ASM_addr_L);
			strcpy(ASM_string_1, ASM_temp);
		} 
		else if ( (nb_bracket==0) && (is_table > 1) ) { // pointer(constant) to a table
			total_code_size=0;
			dec_to_hex (object_list[id_object].addr_L, ASM_temp);
			strcpy (ASM_string_1, ASM_temp);
		}
		else if (nb_bracket==1) { //with 1 brackets	
			if (object_list[id_object].object_type == charact) {
				sprintf(local_bas, "%s+%d", between_brackets_1, object_list[id_object].addr_L);
			} else if (object_list[id_object].object_type == integer) {
				sprintf(local_bas, "(%s*2)+%d", between_brackets_1, object_list[id_object].addr_L);
			}
			local_code_size = parse_expression(local_bas, ASM_temp, 'C', &expr_type_A, line_nb, function_id);
			strcpy(ASM_string_1, ASM_temp);
			sprintf(ASM_temp, "MOVE_C_TO:16:addr_%c_L\n",AB_port);
			strcat(ASM_string_1, ASM_temp);
			total_code_size = local_code_size + 1; //2
		} 
		else if (nb_bracket==2) { // with 2 brackets
			if (object_list[id_object].object_type == charact) {
				sprintf(local_bas, "((%s*%d)+%s)+%d", between_brackets_1, object_list[id_object].size_2, between_brackets_2, object_list[id_object].addr_L);
			}
			else if (object_list[id_object].object_type == integer) {
				sprintf(local_bas, "(((%s*%d)+%s)*2)+%d", between_brackets_1, object_list[id_object].size_2, between_brackets_2, object_list[id_object].addr_L);
			}
			local_code_size = parse_expression(local_bas, ASM_temp, 'C', &expr_type_A, line_nb, function_id);
			strcpy(ASM_string_1, ASM_temp);
			sprintf(ASM_temp, "MOVE_C_TO:16:addr_%c_L\n",AB_port);
			strcat(ASM_string_1, ASM_temp);
			total_code_size = local_code_size + 1; //2
		}
		if (object_list[id_object].object_type == cache ) {
			sprintf(ASM_temp, "CACHE_%d", object_list[id_object].addr_L ); 
			strcpy(ASM_string_1, ASM_temp);
			total_code_size = 10000;
		}
		
		sprintf(ASM_temp, "%d", loc_obj_size); // warning \n deleted !
		strcpy(ASM_string_2, ASM_temp);
	}
	return total_code_size;
}

void functions_first_pass(int nb_basic_lines) {
	char basic_temp[2000];
	char basic_temp2[2000];
	char* local_type_char;
	char* local_name;
	int local_type_int;
	int i,j;
	int is_function=0;
	int function_counter=0;
	
	for (i=0; i<=nb_basic_lines; i++) {
		
		if (line_type[i]==subf) {// function beginning (subf or ASMf or macro)
			if (is_function == 1) {
				printf ("ERROR already inside a function, line %d\r\n", i);
				exit (EXIT_FAILURE);
			}
			function_counter++;
			is_function = 1;
			
			strcpy (basic_temp, basic_lines[i]+1);
			local_type_char = strtok (basic_temp, " ");
			local_name = strtok (NULL, " (");
			if (local_name==0) {
				printf ("ERROR bad function declaration, missing name, line %d\r\n", i);
				exit (EXIT_FAILURE);
			}
			local_type_int=0;
			if (strcmp(local_type_char, "subf") == 0) {		local_type_int=1;}
			if (strcmp(local_type_char, "ASMf") == 0) {		local_type_int=2;}
			if (strcmp(local_type_char, "macro") == 0) {	local_type_int=3;}
			
			strcpy (functions_name [function_counter], local_name);
			functions_type [function_counter] = local_type_int; 
			functions_basic_begin [function_counter] = i;
			for (j=1; j<function_counter; j++) { //check existing names
				if ( strcmp(functions_name[j], local_name) == 0) {
					printf ("ERROR function name already exists, line %d\r\n", i);
					exit (EXIT_FAILURE);	
				}
			}
			if ( (function_counter == 1) && (strcmp(functions_name[1], "main") != 0) ) {
				printf ("ERROR first function must be 'main', line %d\r\n", i);
				exit (EXIT_FAILURE);
			}
		}
		if (is_function == 1) {basic_lines_function[i] = function_counter;}
		else {basic_lines_function[i] = 0;}

		delete_spaces (basic_lines[i], basic_temp2);
		if ( (line_type[i]==instruction) && (strcmp(basic_temp2, "endfunct")==0) ) {// end
			if (is_function == 0) {
				printf ("ERROR no function to close, line %d\r\n", i);
				exit (EXIT_FAILURE);
			}
			is_function = 0;
		}	
	}
	if (is_function == 1) {
		printf ("ERROR waiting 'endfunct' at end of file\r\n", i);
		exit (EXIT_FAILURE);
	}
	nb_functions = function_counter;
	

}

void functions_second_pass (int nb_basic_lines) {// detection of "in xx: out xx"
	char inside_parenth[1000];
	char inside_parenth2[1000];
	char basic_temp[500];
	char basic_temp2[500];
	int line_nb=0;
	int function_id=0;
	char* current_inout_raw;
	char inout_table[50][50];
	char ASM_trash1[500];
	char ASM_trash2[500];
	char cache_check[500];
	char* inout_type_char;
	char* inout_var_char;
	int inout_type_int; 
	int inout_var_int;
	int inout_count;
	int in_count;
	int out_count;
	int loc_funct_type;
	int inside_a_macro=0;
	int i=0;
	int j=0;
	for (line_nb=1; line_nb< nb_basic_lines; line_nb++) {
		function_id = basic_lines_function [line_nb];
		loc_funct_type = functions_type [function_id];
		if ( (line_type[line_nb]==subf) && (loc_funct_type ==3 ) ) { // macro beginning
			get_internal_parenthesis ( basic_lines[line_nb], inside_parenth );
			delete_spaces (inside_parenth, inside_parenth2);
			in_count = 0;
			sscanf (inside_parenth2, "%d", &in_count);
			functions_in_count [function_id] = in_count; 
			inside_a_macro = 1;
		} 
		else if ( (inside_a_macro == 1) && (line_type[line_nb]==instruction) )  {
			delete_spaces (basic_lines [line_nb], basic_temp2);
			line_type [line_nb] = macro;
			if ( strcmp(basic_temp2, "endfunct") == 0 ) {inside_a_macro = 0;}
		}

		if ( (line_type[line_nb]==subf) && (loc_funct_type !=3 ) ) { // subf or ASMf
			in_count=0;
			out_count=0;
			inout_count=0;
			get_internal_parenthesis ( basic_lines[line_nb], inside_parenth );
			current_inout_raw = strtok (inside_parenth, ",");
			while (current_inout_raw !=0) { // new inout detected stored in char table
				strcpy (inout_table[inout_count], current_inout_raw);
				inout_count++;
				current_inout_raw = strtok (NULL, ",");
			}
			for (i=0; i<inout_count; i++) {
				j=0;
				while (inout_table[i][j]==' ') {j++;} //ignores spaces at begining
				inout_type_char = strtok (inout_table[i]+j, " ");
				inout_var_char = strtok (NULL, " ");
				if (inout_var_char==0) {
					printf ("ERROR function parameter missing, line %d\r\n", line_nb);
					exit (EXIT_FAILURE);
				}
				inout_type_int=0;
				if ( strcmp(inout_type_char, "in") == 0 ) {inout_type_int=1;}
				if ( strcmp(inout_type_char, "out") == 0 ) {inout_type_int=2;}
				if (inout_type_int == 0) {
					printf ("ERROR 'in' or 'out' missing, line %d\r\n", line_nb);
					exit (EXIT_FAILURE);
				}
				if (inout_type_int == 1) { //input
					strcpy (functions_input[function_id][in_count], inout_var_char);
					in_count++;
				}
				if (inout_type_int == 2) { //output
					strcpy (functions_output[function_id][out_count], inout_var_char);
					out_count++;
				}
				strcpy (cache_check, inout_var_char);
				cache_check[6] = 0;
				if ( strcmp(cache_check, "CACHE_") !=0 ) {
					lookfor_variable (inout_var_char, function_id, line_nb, 'F', ASM_trash1, ASM_trash2);
				}
			}
			functions_in_count[function_id] = in_count;
			functions_out_count[function_id] = out_count;
		} //end subf or ASMf
	}
}

void manage_define(int nb_lines_basic) {
	char define_labels[100][100];
	char define_values[100][100];

	int i,j;
	int index_define;
	int nb_labels = 0;
	char line_loc[1000];
	char line_loc_subst[1000];
	char* truc;
	char* label_loc;
	char* value_loc;
	char* begin_subst; 
	char* end_subst;
	char* end_basic;
	for (i=1; i<=nb_lines_basic; i++) { // first pass: read definitions
		if (line_type[i] == define) {
			nb_labels++;
			strcpy (line_loc, basic_lines[i]);
			truc = strtok (line_loc, " ");
			label_loc = strtok (NULL, " ");
			value_loc = strtok (NULL, " ");
			strcpy (define_labels[nb_labels], label_loc);
			strcpy (define_values[nb_labels], value_loc);
		}
	}
	for (i=1; i<=nb_lines_basic; i++) {// second pass: substitute (only inside instructions)
		if ((line_type[i] == instruction)||(line_type[i] == macro) ) {
			strcpy (line_loc, basic_lines[i]);
			begin_subst =0;
			begin_subst = strtok (line_loc, "@");
			label_loc = strtok (NULL, ";");
			if (label_loc != 0) { // '@' found
				strcpy (line_loc_subst, begin_subst);
				end_basic = strtok (NULL, ";");
				value_loc = 0;
				for (j=1; j<=nb_labels; j++) {
					if ( strcmp(label_loc, define_labels[j]) == 0 ) {
						value_loc = define_values[j];
					}
				}
				if (value_loc == 0) {
					printf ("ERROR no '#define' found for '%s', line %d\r\n", label_loc, i);
					exit (EXIT_FAILURE);
				}
				strcat (line_loc_subst, value_loc);
				if (end_basic != 0) {
					strcat(line_loc_subst, end_basic);
				}
				strcpy (basic_lines[i], line_loc_subst);
			}
		}
	}
}

void manage_appli_config (int nb_lines) {
	int i;
	int loc_code_size_max;
	int loc_var_size_max;
	int loc_separation = 0;
	char line_loc[500];

	for (i=1; i<=nb_lines; i++) {
		if (line_type[i]  == appli_config) {
			strcpy (line_loc, basic_lines[i]);
			sscanf (line_loc, "#appli_config %d,%d,%d,%x", &loc_code_size_max, &loc_var_size_max, &loc_separation, &offset_H);
			printf ("    appli config detected: %d & %d & %d & %x\r\n", loc_code_size_max, loc_var_size_max, loc_separation, offset_H);
		}
	}
	if (loc_separation == 0) {
		printf ("ERROR, no correct '#appli_config' detected\r\n");
		exit (EXIT_FAILURE);
	}
	if ( (loc_code_size_max > 131072) || (loc_var_size_max > 65536) ) {
		printf ("ERROR, at '#appli_config', too big size\r\n");
		exit (EXIT_FAILURE);
	}
	var_max_size = loc_var_size_max;
	code_max_size = loc_code_size_max;
	code_var_separation = loc_separation;
	if (loc_separation == 1) { // 1 part for both code and var
		var_addr_offset_out = code_max_size - var_max_size;
		tot_bin_size = code_max_size;
	}
	if (loc_separation == 2) { // 2 parts : 1 for code and 1 for var
		var_addr_offset_out = code_max_size;
		tot_bin_size = code_max_size + var_max_size;
	}
	
}

int parse_single_expr (char* input_string, char* ASM_string, char BC_dest, int *expr_type, int function_id, int line_nb) {
	int local_code_size=1;
	int temp_code_size_1, temp_code_size_2;
	char ASM_temp_1[2000];
	char ASM_temp_2[1000];
	char ASM_temp[1000];
	char basic_temp[20];
	int i;
	int is_cache = 0;
	int local_const;
	*expr_type=0; //
	for (i=0; i<=5; i++) {
		basic_temp[i] = input_string[i];
	}
	basic_temp[6]=0;
	if (isalpha (input_string[0])) {
		if (strcmp(basic_temp, "CACHE_") == 0)	{is_cache=1;}
		if (strcmp(input_string, "ext_A") == 0) {is_cache=1;}
		if (strcmp(input_string, "ext_B") == 0) {is_cache=1;}
		if (strcmp(input_string, "STATUS") == 0) {is_cache=1;}
		if (is_cache == 1) {
			*expr_type=2; //CACHE
			local_code_size=0;
			strcpy(ASM_string,input_string);
		}
		else {
		
			*expr_type=3; //variable
			temp_code_size_1=lookfor_variable(input_string, function_id, line_nb, 'A', ASM_temp_1, ASM_temp_2); 
			strcpy(ASM_string, ASM_temp_1); //address elaboration
			sprintf(ASM_temp, "MOVE_TO_%c:",BC_dest);
			strcat(ASM_string, ASM_temp);
			strcat(ASM_string, ASM_temp_2); //copy to C with good size
			strcat(ASM_string, ":ext_A\n"); 
			local_code_size=temp_code_size_1 + 1;
			if (temp_code_size_1 == 0) { //pointer (constant) to a table
				*expr_type=1;
				strcpy (ASM_string, ASM_temp_1);
			}
			if (temp_code_size_1 == 10000) { // CACHE variable (very dirty!)
				*expr_type=2; //CACHE
				local_code_size=0;
				strcpy (ASM_string, ASM_temp_1);
			}
		}
	}
	if (isdigit(input_string[0])) { //constant immediate
		*expr_type=1; //constant
		if ((input_string[0]=='0') && (input_string[1]=='x')) {//hexa constant
			strcpy(ASM_string, input_string+2);
			local_code_size = 0;
			if ((input_string[5] == 0) || (input_string[6] != 0)) {
				printf("ERROR hexa value must have 4 digits, line %d\r\n", line_nb);
				exit(EXIT_FAILURE);
			}
		} else { //decimal constant
			sscanf(input_string, "%d", &local_const);
			dec_to_hex(local_const, ASM_temp_1);
			strcpy(ASM_string, ASM_temp_1);
			local_code_size = 0;
		}
	}
	return local_code_size;
}

int parse_expression (char* input_string, char* ASM_string, char BC_dest, int *expr_type, int line_nb, int function_id) {
	int local_code_size;
	int total_code_size=0;
	int coherence_err;
	int op_position;
	int op_size;
	int expr_type_A;
	int expr_type_B;
	char local_op;
	char input_string_copy[2000];
	char input_string_spaceless[2000];
	char* string_useless_ext_parenth;
	char str_mask_int_parenth[2000];
	char in_sub_str_1[2000];
	char in_sub_str_2[2000];
	char ASM_op [10];
	char ASM_temp[100];
	char ASM_string_A[2000];
	char ASM_string_B[2000];
	char ASM_string_3[2000];
	int size_code_A, size_code_B, size_code_C;
	strcpy(input_string_copy, input_string);
	delete_spaces(input_string_copy, input_string_spaceless);
	coherence_err=check_parenthesis_coherence(input_string_spaceless);
	if (coherence_err==1) {
		printf ("ERROR parentheses, line %d\r\n", line_nb);
		exit (EXIT_FAILURE);
	}
	string_useless_ext_parenth=delete_ext_parenthesis (input_string_spaceless);
	strcpy (str_mask_int_parenth, string_useless_ext_parenth);
	ignore_internal_parenthesis	(str_mask_int_parenth);
	local_op=check_ALU_op(str_mask_int_parenth, ASM_op, &op_position, &op_size);
	split_sub_expressions(string_useless_ext_parenth, in_sub_str_1, in_sub_str_2, local_op, op_position, op_size);

	
	if (local_op!=0) { // mono or 2 operands expressions evaluate expr_A
		size_code_A = parse_expression(in_sub_str_1, ASM_string_A, 'C', &expr_type_A, line_nb, function_id);
		size_code_B = parse_expression(in_sub_str_2, ASM_string_B, 'B', &expr_type_B, line_nb, function_id);
		i_cache_express++;
		if ((expr_type_A==0)||(expr_type_A==3)) { //variable or compute
			strcpy (ASM_string, ASM_string_A);
			sprintf(ASM_temp,"MOVE_C_TO:16:CACHE_%d\n", i_cache_express + offset_cache_express);
			strcat (ASM_string, ASM_temp);
			total_code_size = size_code_A +1;
		}
		if (expr_type_A==1) { // constant
			sprintf(ASM_temp, "WRITE:16:CACHE_%d:%s\n", i_cache_express + offset_cache_express, ASM_string_A);
			strcpy (ASM_string, ASM_temp);
			total_code_size = 2;
		}
		if (expr_type_A==2) { // Cache
			strcpy (ASM_string, "");
			total_code_size = 0;
		}
	}
	if ((local_op!=0)&&(local_op!='!')) { // 2 operands evaluate expr_B
		if (expr_type_B == 0) { // compute
			strcat (ASM_string, ASM_string_B);
			sprintf(ASM_temp, "MOVE_C_TO:16:B\n");
			strcat (ASM_string, ASM_temp);
			total_code_size = total_code_size + size_code_B + 1;
		}
		if (expr_type_B == 3) { // variable
			strcat (ASM_string, ASM_string_B);
			total_code_size = total_code_size + size_code_B;
		}
		if (expr_type_B==1) { //constant
			//nothing to do
		}
		if (expr_type_B==2) { // cache
			sprintf(ASM_temp, "MOVE_TO_B:16:%s\n", ASM_string_B);
			strcat (ASM_string, ASM_temp);
			total_code_size = total_code_size + 1;
		}
	}

	if (local_op=='!') { //mono operand evaluate ALU
		if (expr_type_A==2)	{// cache
			sprintf(ASM_temp,"ALU:16:NOT:%s\n", ASM_string_A);
			strcpy (ASM_string, ASM_temp);
			total_code_size=1;
		} 
		else { // other than CACHE
			sprintf(ASM_temp,"ALU:16:NOT:CACHE_%d\n", i_cache_express + offset_cache_express);
			strcat (ASM_string, ASM_temp);
			total_code_size = total_code_size + 1;
		}
	}

	if ((local_op!=0)&&(local_op!='!')) { //2 operands evaluate ALU
		if ( (expr_type_A != 2) && (expr_type_B != 1) ) { // A not cache; B not constant
			sprintf(ASM_temp,"ALU:16:%s:CACHE_%d\n", ASM_op, i_cache_express + offset_cache_express);
			strcat (ASM_string, ASM_temp);
			total_code_size = total_code_size + 1;
		}
		if ( (expr_type_A != 2) && (expr_type_B == 1) ) { // A not cache; B is constant
			sprintf(ASM_temp,"ALU_CONS:16:%s:CACHE_%d:%s\n", ASM_op, i_cache_express + offset_cache_express, ASM_string_B);
			strcat (ASM_string, ASM_temp);
			total_code_size = total_code_size + 2;
		}

		if ( (expr_type_A == 2) && (expr_type_B != 1) ) { // A is cache; B not constant
			sprintf(ASM_temp,"ALU:16:%s:%s\n", ASM_op, ASM_string_A);
			strcat (ASM_string, ASM_temp);
			total_code_size = total_code_size + 1;
		}
		if ( (expr_type_A == 2) && (expr_type_B == 1) ) { // A is cache; B is constant
			sprintf(ASM_temp,"ALU_CONS:16:%s:%s:%s\n", ASM_op, ASM_string_A, ASM_string_B);
			strcat (ASM_string, ASM_temp);
			total_code_size = total_code_size + 2;
		}
	}
	
	//special for ALU (variable, cste). Dirty code...
	if ( (local_op!=0) && (local_op!='!') && (expr_type_A==3) && (expr_type_B==1) ) {
		total_code_size = lookfor_variable (in_sub_str_1, function_id, line_nb, 'A', ASM_string_A, ASM_string_3);
		total_code_size = total_code_size + 2;
		strcpy (ASM_string, ASM_string_A);
		sprintf(ASM_temp,"ALU_CONS:%s:%s:ext_A:%s\n", ASM_string_3, ASM_op, ASM_string_B);
		strcat (ASM_string, ASM_temp);

	}

	*expr_type=0; // by default different from constant
	if (local_op==0) { // single expression
		total_code_size = parse_single_expr (string_useless_ext_parenth, ASM_string_A, BC_dest, expr_type, function_id, line_nb);
		strcpy (ASM_string, ASM_string_A);
	}
	return total_code_size;
}

int parse_assign (char* input_string, char* ASM_string, int line_nb, int function_source, int function_dest) {
	char BASIC_source [1000];
	char BASIC_dest [1000];
	char BASIC_dest_cache[1000];
	char BASIC_temp [1000];
	char ASM_dest_1 [1000];
	char ASM_dest_2 [1000];
	char ASM_source_1 [1000];
	char ASM_temp [1000];
	char* begin_equal;
	int total_code_size=0;
	int code_size_temp;
	int source_type, dest_type=0; 
	delete_spaces (input_string+7, BASIC_dest);
	begin_equal = strchr (BASIC_dest, '=');
	if (begin_equal == 0) {
		printf ("ERROR assign without '=' line %d\r\n", line_nb);
		exit (EXIT_FAILURE);
	} else {
		strcpy(BASIC_source, begin_equal+1); // after "="
		begin_equal[0] = 0; // terminates BASIC_dest
		strcpy (BASIC_dest_cache, BASIC_dest);
		BASIC_dest_cache [6] = 0;
		if ( strcmp(BASIC_dest_cache, "CACHE_") == 0) { dest_type=2; strcpy (ASM_string, ""); }
		else if ( strcmp(BASIC_dest, "ext_A") == 0) { dest_type=2; strcpy (ASM_string, ""); }
		else if ( strcmp(BASIC_dest, "ext_B") == 0) { dest_type=2; strcpy (ASM_string, ""); }
		else if ( strcmp(BASIC_dest, "addr_A_H") == 0) { dest_type=2; strcpy (ASM_string, ""); }
		else if ( strcmp(BASIC_dest, "addr_A_L") == 0) { dest_type=2; strcpy (ASM_string, ""); }
		else if ( strcmp(BASIC_dest, "addr_B_H") == 0) { dest_type=2; strcpy (ASM_string, ""); }
		else if ( strcmp(BASIC_dest, "addr_B_L") == 0) { dest_type=2; strcpy (ASM_string, ""); }
		else if ( strcmp(BASIC_dest, "PC_H") == 0) { dest_type=2; strcpy (ASM_string, ""); }
		else if ( strcmp(BASIC_dest, "PC_L") == 0) { dest_type=2; strcpy (ASM_string, ""); }
		else if ( strcmp(BASIC_dest, "CONFIG") == 0) { dest_type=2; strcpy (ASM_string, ""); }
		else if (strcmp(BASIC_dest, "COUNTER") == 0) { dest_type = 2; strcpy(ASM_string, ""); }
		else {
			dest_type=3; // variable
			total_code_size = lookfor_variable (BASIC_dest, function_dest, line_nb, 'B', ASM_dest_1, ASM_dest_2);
			strcpy(ASM_string, ASM_dest_1); // destination address computation
			if (total_code_size == 0) {
				printf("ERROR '%s' is a constant pointer, line %d\r\n", BASIC_dest, line_nb);
				exit (EXIT_FAILURE);
			}
			if (total_code_size==10000) { // CACHE variable Dirty!
				dest_type=2;
				total_code_size=0;
				strcpy (ASM_string, "");
				strcpy (BASIC_dest, ASM_dest_1);
			}
		} 
		// source parsing
		code_size_temp = parse_expression(BASIC_source, ASM_source_1, 'C', &source_type, line_nb, function_source);
		if ( (source_type == 0) || (source_type == 3) ) { //source is ALU or variable
			strcat(ASM_string, ASM_source_1); // computation into C
			total_code_size = total_code_size + code_size_temp;
		}
		if (source_type == 2) { //source is cache
			sprintf (ASM_temp, "MOVE_TO_C:16:%s\n", ASM_source_1);
			strcat (ASM_string, ASM_temp); 
			total_code_size = total_code_size + 1;
		}
		// final assignment
		if ((source_type != 1) && (dest_type == 3) ) { //not constant TO variable
			sprintf (ASM_temp, "MOVE_C_TO:%s:ext_B\n", ASM_dest_2);
			strcat (ASM_string, ASM_temp); 
			total_code_size = total_code_size + 1;
		}
		if ((source_type != 1) && (dest_type == 2) ) { //not constant TO cache
			sprintf (ASM_temp, "MOVE_C_TO:16:%s\n", BASIC_dest);
			strcat (ASM_string, ASM_temp); 
			total_code_size = total_code_size + 1;
		}
		if ((source_type == 1) && (dest_type == 3) ) { // constant TO variable
			sprintf (ASM_temp, "WRITE:%s:ext_B:%s\n", ASM_dest_2, ASM_source_1);
			strcat (ASM_string, ASM_temp); 
			total_code_size = total_code_size + 2;
		}
		if ((source_type == 1) && (dest_type == 2) ) { // constant TO CACHE
			sprintf (ASM_temp, "WRITE:16:%s:%s\n", BASIC_dest, ASM_source_1);
			strcat (ASM_string, ASM_temp); 
			total_code_size = total_code_size + 2;
		}
	}
	return total_code_size;
}

int parse_while (char* input_string, char* ASM_string, int line_nb, int function_id) {
	char BASIC_input[1000];
	char BASIC_condition[1000];
	char BASIC_condition2[1000];
	char ASM_cond[1000];
	char ASM_temp[1000];
	int total_code_size = 0;
	int index_parentheses = 0;
	int cond_expr_type=0;
	manage_openning_accolade (line_nb, 1);
	delete_spaces (input_string+5, BASIC_input);
	get_internal_parenthesis (BASIC_input, BASIC_condition);
	if ( strcmp(BASIC_condition, "1") == 0 ) {	// while (1)
		strcpy (ASM_string, " ");
		total_code_size = 0;
	} else {									// while not constant
		strcpy (BASIC_condition2, "(");//!
		strcat (BASIC_condition2, BASIC_condition); 
		strcat (BASIC_condition2, ")");
		total_code_size = parse_expression (BASIC_condition2, ASM_cond, 'C', &cond_expr_type, line_nb, function_id);
		strcpy (ASM_string, ASM_cond); 
		sprintf (ASM_temp, "COND_WRITE:16:PC_L:MARKER_WEND_%d\n", accolade_index);
		total_code_size = total_code_size + 2;
		strcat (ASM_string, ASM_temp); 
	}
	return total_code_size;
}

int parse_for (char* input_string, char* ASM_string, int line_nb, int function_id) { 
	char BASIC_input[1000];
	char BASIC_inside[1000];
	char BASIC_temp[1000];
	char* BASIC_for_1;
	char* BASIC_for_2;
	char* BASIC_for_3;
	char BASIC_condition[1000];
	char ASM_cond[1000];
	char ASM_temp[1000];
	int total_code_size = 0;
	int code_size_1=0;
	int code_size_2=0;
	int index_parentheses = 0;
	int cond_expr_type=0;

	delete_spaces (input_string+3, BASIC_input);
	get_internal_parenthesis (BASIC_input, BASIC_inside);
	BASIC_for_1 = strtok(BASIC_inside, ":");
	BASIC_for_2 = strtok(NULL, ":");
	BASIC_for_3 = strtok(NULL, ":");
	if (BASIC_for_3==0) {
		printf ("ERROR missing 'for' arg line %d. Remind separator ':'\r\n", line_nb);
		exit (EXIT_FAILURE);
	}

	manage_openning_accolade (line_nb, 4); 
	// 1st part : assign initial value
	strcpy (BASIC_temp, "assign ");
	strcat (BASIC_temp, BASIC_for_1);
	code_size_1 = parse_assign (BASIC_temp, ASM_temp, line_nb, function_id, function_id);
	ASM_pos_abs = ASM_pos_abs + code_size_1;
	strcpy (ASM_string, ASM_temp);
	ASM_pos_midfor[line_nb] = ASM_pos_abs; 
	// 2nd part : check condition
	strcpy (BASIC_condition, "(");//!
	strcat (BASIC_condition, BASIC_for_2); 
	strcat (BASIC_condition, ")");
	i_cache_express = 0; //warning not tested
	code_size_2 = parse_expression (BASIC_condition, ASM_cond, 'C', &cond_expr_type, line_nb, function_id);
	strcat (ASM_string, ASM_cond); 
	sprintf (ASM_temp, "COND_WRITE:16:PC_L:MARKER_NEXT_%d\n", accolade_index);
	strcat (ASM_string, ASM_temp); 
	ASM_pos_abs = ASM_pos_abs + code_size_2 + 2;
	//3rd part : increment
	strcpy (accolade_next_content[accolade_index], BASIC_for_3);

	total_code_size = code_size_1 + code_size_2;
	return total_code_size;
}


int parse_if (char* input_string, char* ASM_string, int line_nb, int function_id) { 
	char BASIC_input[1000];
	char BASIC_condition[1000];
	char BASIC_condition2[1000];
	char ASM_cond[1000];
	char ASM_temp[1000];
	int total_code_size = 0;
	int index_parentheses = 0;
	int cond_expr_type=0;

	delete_spaces (input_string+2, BASIC_input);
	get_internal_parenthesis (BASIC_input, BASIC_condition);
	strcpy (BASIC_condition2, "(");//!
	strcat (BASIC_condition2, BASIC_condition); 
	strcat (BASIC_condition2, ")");
	total_code_size = parse_expression (BASIC_condition2, ASM_cond, 'C', &cond_expr_type, line_nb, function_id);
	strcpy (ASM_string, ASM_cond); 
	manage_openning_accolade (line_nb, 2); 
	sprintf (ASM_temp, "COND_WRITE:16:PC_L:MARKER_ENDIF_%d\n", accolade_index);
	total_code_size = total_code_size + 2;
	strcat (ASM_string, ASM_temp); 
	return total_code_size;
}

int parse_else (char* input_string, char* ASM_string, int line_nb, int function_id) { 
	char BASIC_input[1000];
	char BASIC_condition[1000];
	char BASIC_condition2[1000];
	char ASM_cond[1000];
	char ASM_temp[1000];
	int total_code_size = 0;
	int index_parentheses = 0;
	//int loc_accolade_index = 0;
	int cond_expr_type=0;

	manage_openning_accolade (line_nb, 3); 
	sprintf (ASM_temp, "WRITE:16:PC_L:MARKER_ENDELSE_%d\n", accolade_index);
	total_code_size = 2;
	strcpy (ASM_string, ASM_temp); 
	return total_code_size;
}

int parse_next (char* ASM_string, int loc_accolade_index, int line_nb, int function_id) { 
	char BASIC_input[1000];
	char ASM_temp[1000];
	int total_code_size = 0;
	int index_parentheses = 0;
	int cond_expr_type=0;
	strcpy (BASIC_input, "assign ");
	strcat (BASIC_input, accolade_next_content[loc_accolade_index]);
	total_code_size = parse_assign(BASIC_input, ASM_temp, line_nb, function_id, function_id);
	strcpy (ASM_string, ASM_temp);
	
	sprintf (ASM_temp, "WRITE:16:PC_L:MARKER_FOR_%d\n", loc_accolade_index); //MODIF!!!
	total_code_size = total_code_size+2;
	strcat (ASM_string, ASM_temp); 
	return total_code_size;
}

void parse_label (char* input_string, int line_nb) {
	char basic_temp[1000];
	int loc_mark_index=0;
	delete_spaces (input_string+6, basic_temp);
	sscanf (basic_temp, "%d", &loc_mark_index);
	if (accolade_basic_begin[loc_mark_index] != 0) {
		printf("ERROR label %d already used, line %d\r\n", loc_mark_index, line_nb);
		exit(EXIT_FAILURE);
	}
	accolade_basic_begin[loc_mark_index] = line_nb;
}

void parse_goto (char* input_string, char* ASM_string, int line_nb) {
	char basic_temp[1000];
	char ASM_temp[1000];
	int loc_mark_index=0;
	delete_spaces (input_string+4, basic_temp);
	sscanf (basic_temp, "%d", &loc_mark_index);
	sprintf (ASM_temp, "WRITE:16:PC_L:MARKER_LABEL_%d\n", loc_mark_index);
	strcpy (ASM_string, ASM_temp);
}

void parse_condgoto (char* input_string, char* ASM_string, int line_nb) {
	char basic_temp[1000];
	char ASM_temp[1000];
	int loc_mark_index=0;
	delete_spaces (input_string+8, basic_temp);
	sscanf (basic_temp, "%d", &loc_mark_index);
	sprintf (ASM_temp, "COND_WRITE:16:PC_L:MARKER_LABEL_%d\n", loc_mark_index);
	strcpy (ASM_string, ASM_temp);
}

int parse_endfunct (char* ASM_string, int line_nb, int function_id) {
	char ASM_temp[1000];
	int code_size = 0;
	int loc_funct_type = 0;
	if (accolade_depth > 0) {
		printf ("ERROR missing '}' before endfunct, line %d\r\n", line_nb);
		exit (EXIT_FAILURE);
	}
	loc_funct_type = functions_type [function_id];
	if (loc_funct_type == 1) { //subf
		if (function_id == 1) {// Main 
			strcpy(ASM_string, "WRITE:16:CONFIG:0001\n");
			code_size = 2;
		}
		else {
			strcpy(ASM_string, "MOVE_TO_C:16:CACHE_2\n");
			strcat(ASM_string, "MOVE_C_TO:16:addr_A_L\n"); //stack access
			strcat(ASM_string, "ALU_CONS:16:SUBS:CACHE_2:0002\n"); //decrement stack pointer 2 
			strcat(ASM_string, "MOVE_C_TO:16:CACHE_2\n");
			strcat(ASM_string, "MOVE_TO_C:16:ext_A\n"); //get return address from stack
			strcat(ASM_string, "MOVE_C_TO:16:PC_L\n");
			code_size = 7;
		}
	}
	
	if (loc_funct_type == 2) { //ASMf
		strcpy (ASM_string, "MOVE_TO_C:16:CACHE_1\n");
		strcat (ASM_string, "MOVE_C_TO:16:PC_L\n");
		code_size = 2;
	}

	return code_size;
}

int parse_macro_call (char* inside_parenth, char* ASM_string, int called_function, int calling_function, int line_nb) {
	int code_size=0;
	int temp_code_size;
	char ASM_temp [1000];
	char basic_raw[1000];
	char basic_temp[1000];
	char basic_modified[1000];
	char loc_args[50][50];
	int macro_basic_line;
	char* current_inout;
	char* basic_remaining; 
	char* alias_begin;
	char* end_alias;
	int is_end = 0;
	int i=0;
	char index_alias_char[5];
	int index_alias_int;
	strcpy (ASM_string, "");
	macro_basic_line = functions_basic_begin [called_function] + 1; //ignores declaration
	// read arguments
	current_inout = strtok (inside_parenth, ",");
	for (i=1; i<=functions_in_count [called_function]; i++) {
		if (current_inout==0) {
			printf ("ERROR too few arguments, line %d\r\n", line_nb);
			exit (EXIT_FAILURE);
		}
		strcpy (loc_args[i], current_inout); //store arguments
		current_inout = strtok (NULL, ",");
	}
	if (current_inout!=0) {
		printf ("ERROR too many arguments, line %d\r\n", line_nb);
		exit (EXIT_FAILURE);
	}
	//each basic line of macro 
	strcpy (basic_modified, "");
	strcpy (basic_raw, basic_lines [macro_basic_line]);
	
	delete_spaces (basic_raw, basic_temp);
	while ( strcmp(basic_temp, "endfunct") !=0) { //until end of macro
		strcpy (basic_modified, "");
		if (line_type[macro_basic_line] == macro) { 
			basic_remaining = basic_raw;
			end_alias = basic_raw; 
			alias_begin = strstr (basic_remaining, "ALIAS_");
			while (alias_begin != 0) {
				end_alias = alias_begin + 8; // fixed length
				alias_begin[0] = 0; //for strcpy of previous
				index_alias_char[0] = alias_begin[6];
				index_alias_char[1] = alias_begin[7];
				index_alias_char[2] = 0;
				sscanf (index_alias_char, "%d", &index_alias_int);
				strcat (basic_modified, basic_remaining);
				strcat (basic_modified, loc_args[index_alias_int]);
				basic_remaining = end_alias;
				alias_begin = strstr (basic_remaining, "ALIAS_");
			}
			strcat (basic_modified, basic_remaining);
			temp_code_size = parse_instruction (basic_modified, ASM_temp, line_nb, calling_function);
			strcat (ASM_string, ASM_temp);
			code_size = code_size + temp_code_size;
		}
		//check new macro basic line
		macro_basic_line++;
		strcpy (basic_raw, basic_lines [macro_basic_line]);
		delete_spaces (basic_raw, basic_temp);
	}
	return code_size;
}

char ASM_temp_funct_call[10000];
int parse_function_call (char* input_string, char* ASM_string, int line_nb) {
	char basic_temp[1000];
	char inside_parenth[1000];
	char ASM_temp[1000];
	char assign_temp[1000];
	int return_address_int;
	char return_address_char[20];
	char* funct_label;
	char* current_inout;
	int code_size = -1000;
	int i;
	int temp_code_size;
	int called_function = -1;
	int calling_function = -1;
	int called_funct_type = -1;
	int calling_funct_type = -1;

	calling_function = basic_lines_function [line_nb];
	calling_funct_type = functions_type [calling_function];
	strcpy (basic_temp, input_string);
	strcpy (ASM_string, "");
	funct_label = strtok (basic_temp, " (");
	get_internal_parenthesis ( basic_lines[line_nb], inside_parenth );

	for (i=1; i<=nb_functions; i++) { // search function name
		if ( strcmp(functions_name[i], funct_label) == 0) {called_function = i;}
	}
	if (called_function < 0) {
		printf ("ERROR '%s' is unknown instruction or function, line %d\r\n", funct_label, line_nb);
		exit (EXIT_FAILURE);
	}
	if (called_function >0) {
		if (called_function == calling_function) {
			printf ("ERROR recursive function call, line %d\r\n", line_nb);
			exit (EXIT_FAILURE);	
		}
		called_funct_type = functions_type [called_function];
		if (calling_funct_type == 3) {
			printf ("ERROR cannot call subf/ASMf/macro inside a macro, line %d\r\n", line_nb);
			exit (EXIT_FAILURE);
		}
		if ( (calling_funct_type == 2) && (called_funct_type != 3) ) {
			printf ("ERROR cannot call subf or ASMf inside an ASMf, line %d\r\n", line_nb);
			exit (EXIT_FAILURE);
		}
		code_size=0; // A CHANGER!!
	}
	
	if (called_funct_type == 3) { //macro
		code_size = parse_macro_call (inside_parenth, ASM_temp_funct_call, called_function, calling_function, line_nb);
		strcpy (ASM_string, ASM_temp_funct_call);
	}

	if (called_funct_type != 3) { // parse subf
		current_inout = strtok (inside_parenth, ",");
		// read and parse inputs
		for (i=0; i<functions_in_count [called_function]; i++) {
			if (current_inout==0) {
				printf ("ERROR too few arguments, line %d\r\n", line_nb);
				exit (EXIT_FAILURE);
			}
			strcpy (assign_temp, "assign ");
			strcat (assign_temp, functions_input[called_function][i]);
			strcat (assign_temp, "=");
			strcat (assign_temp, current_inout);
			temp_code_size = parse_assign (assign_temp, ASM_temp, line_nb, calling_function, called_function);
			code_size = code_size + temp_code_size;
			ASM_pos_abs = ASM_pos_abs + temp_code_size;
			strcat (ASM_string, ASM_temp);
			current_inout = strtok (NULL, ",");
		}
		// manage stack and jump
		
		if (called_funct_type == 1) { // jump for subf
			return_address_int = ASM_pos_abs + 8;
			dec_to_hex (return_address_int, return_address_char);
			strcat (ASM_string, "ALU_CONS:16:ADD:CACHE_2:0002\n"); //increment stack pointer 2!
			strcat (ASM_string, "MOVE_C_TO:16:CACHE_2\n");
			strcat (ASM_string, "MOVE_C_TO:16:addr_A_L\n"); 
			sprintf (ASM_temp, "WRITE:16:ext_A:%s\n", return_address_char);
			strcat (ASM_string, ASM_temp);
			sprintf (ASM_temp, "WRITE:16:PC_L:MARKER_SUBF_%d\n", called_function);
			strcat (ASM_string, ASM_temp);
			ASM_pos_abs = ASM_pos_abs + 8; 
			code_size = code_size + 8;
		}
		if (called_funct_type == 2) { // jump for ASMf
			return_address_int = ASM_pos_abs + 4;
			dec_to_hex (return_address_int, return_address_char);
			sprintf (ASM_temp, "WRITE:16:CACHE_1:%s\n", return_address_char);
			strcat (ASM_string, ASM_temp);
			sprintf (ASM_temp, "WRITE:16:PC_L:MARKER_SUBF_%d\n", called_function);
			strcat (ASM_string, ASM_temp); 
			ASM_pos_abs = ASM_pos_abs + 4;
			code_size = code_size + 4;
		}
		// read and parse outputs
		for (i=0; i<functions_out_count [called_function]; i++) {
			if (current_inout==0) {
				printf ("ERROR too few arguments, line %d\r\n", line_nb);
				exit (EXIT_FAILURE);
			}
			strcpy (assign_temp, "assign ");
			strcat (assign_temp, current_inout);
			strcat (assign_temp, "=");
			strcat (assign_temp, functions_output[called_function][i]);
			temp_code_size = parse_assign (assign_temp, ASM_temp, line_nb, called_function, calling_function);
			code_size = code_size + temp_code_size;
			ASM_pos_abs = ASM_pos_abs + temp_code_size;
			strcat (ASM_string, ASM_temp);
			current_inout = strtok (NULL, ",");
		}
		if (current_inout!=0) {
			printf ("ERROR too many arguments, line %d\r\n", line_nb);
			exit (EXIT_FAILURE);
		}

	} //end parse subf
	
	return code_size;
}

char ASM_temp_instr[10000];
int parse_instruction (char* input_string, char* ASM_string, int line_nb, int function_id) {
	int total_code_size=-1000;
	char line_temp [2000];
	char basic_temp [1000];
	char ASM_temp [2000];
	char ASM_pos_temp[20];
	
	char *type_instr;
	int local_accolade_index=0;
	int local_accolade_type=0;
	int i;
	int is_ASM = 0;
	
	if (basic_lines_function[line_nb] == 0) {
		printf ("ERROR instruction outside a function, line %d\r\n", line_nb);
		exit (EXIT_FAILURE);
	}

	i_cache_express=0;
	strcpy(line_temp, input_string);
	type_instr=strtok(line_temp, " (:");
	strcpy(ASM_string, "");

	if (strcmp(type_instr, "goto") == 0) { // GOTO
		parse_goto (input_string, ASM_temp, line_nb);
		strcat (ASM_string, ASM_temp);
		total_code_size = 2;
		ASM_pos_abs = ASM_pos_abs + total_code_size;
	}
	
	if (strcmp(type_instr, "condgoto") == 0) { // CONDITIONNAL GOTO
		parse_condgoto (input_string, ASM_temp, line_nb);
		strcat (ASM_string, ASM_temp);
		total_code_size = 2;
		ASM_pos_abs = ASM_pos_abs + total_code_size;
	}

	if (strcmp(type_instr, "assign") == 0) { // ASSIGN
		total_code_size = parse_assign (input_string, ASM_temp, line_nb, function_id, function_id);
		strcat (ASM_string, ASM_temp);
		ASM_pos_abs = ASM_pos_abs + total_code_size;
	}
	if (strcmp(type_instr, "while") == 0) { //WHILE
		total_code_size = parse_while (input_string, ASM_temp, line_nb, function_id);
		strcat (ASM_string, ASM_temp);
		ASM_pos_abs = ASM_pos_abs + total_code_size;
	}
	if (strcmp(type_instr, "if") == 0) {	// IF
		total_code_size = parse_if (input_string, ASM_temp, line_nb, function_id);
		strcat (ASM_string, ASM_temp);
		ASM_pos_abs = ASM_pos_abs + total_code_size;
	}
	if (strcmp(type_instr, "for") == 0) {	//FOR
		total_code_size = parse_for (input_string, ASM_temp, line_nb, function_id);
		strcat (ASM_string, ASM_temp);
	}
											// ASM
	if (strcmp(type_instr, "WRITE") == 0) {			is_ASM=1; total_code_size = 2;}
	if (strcmp(type_instr, "COND_WRITE") == 0) {	is_ASM=1; total_code_size = 2;}
	if (strcmp(type_instr, "MOVE_C_TO") == 0) {		is_ASM=1; total_code_size = 1;}
	if (strcmp(type_instr, "COND_MOVE_C_TO") == 0) {is_ASM=1; total_code_size = 1;}
	if (strcmp(type_instr, "MOVE_TO_C") == 0) {		is_ASM=1; total_code_size = 1;}
	if (strcmp(type_instr, "MOVE_TO_B") == 0) {		is_ASM=1; total_code_size = 1;}
	if (strcmp(type_instr, "ALU") == 0) {			is_ASM=1; total_code_size = 1;}
	if (strcmp(type_instr, "ALU_CONS") == 0) {		is_ASM=1; total_code_size = 2;}
	if (is_ASM == 1) {
		strcpy (ASM_string, input_string);
		strcat (ASM_string, "\n");
		ASM_pos_abs = ASM_pos_abs + total_code_size;
	}

	if (strcmp(type_instr, "endfunct") == 0) {	//END FUNCTION !!! A Coder!! 
		total_code_size = parse_endfunct (ASM_temp, line_nb, function_id); 
		strcat (ASM_string, ASM_temp);
		ASM_pos_abs = ASM_pos_abs + total_code_size;
	}

	if (line_temp[0] == '}') {				// CLOSING ACCOLADE
		local_accolade_index = manage_closing_accolade (line_nb);
		local_accolade_type = accolade_type_glob [local_accolade_index];
		if (local_accolade_type == 1) { // WEND
			sprintf(ASM_temp, "WRITE:16:PC_L:MARKER_WHILE_%d\n", local_accolade_index);
			strcat (ASM_string, ASM_temp);
			total_code_size = 2;
			ASM_pos_abs = ASM_pos_abs + total_code_size;
		}
		if (local_accolade_type == 2) { // ENDIF
			delete_spaces (input_string, basic_temp);
			if ( strstr (basic_temp, "else") != 0 ) {
				total_code_size = parse_else (input_string, ASM_temp, line_nb, function_id); 
				strcat (ASM_string, ASM_temp);
				ASM_pos_abs = ASM_pos_abs + total_code_size;
			} else {
				total_code_size = 0;	
			}
		}
		if (local_accolade_type == 3) { //END ELSE
			total_code_size = 0;
		}
		if (local_accolade_type == 4) { //NEXT
			total_code_size = parse_next (ASM_temp, local_accolade_index, line_nb, function_id);
			strcat (ASM_string, ASM_temp);
			ASM_pos_abs = ASM_pos_abs + total_code_size;
		} // end closing accolade
	}
	if (total_code_size < 0) {//no instruction found, look for FUNCTION
		total_code_size = parse_function_call(input_string, ASM_temp_instr, line_nb);
		strcat (ASM_string, ASM_temp_instr);
	}

	if (total_code_size < 0) {
		printf ("ERROR '%s' is unknown instruction or function, line %d\r\n", type_instr, line_nb);
		exit (EXIT_FAILURE);
	}
	return total_code_size;
}

char ASM_temp_marker_subst[500000];
void marker_substitute (char* ASM_markers, char* ASM_out) {
	char marker_string[100];
	char ASM_address[20];
	char* ASM_m_remaining;
	char* end_marker;
	char* begin_marker;
	char* type_marker;
	char* index_marker;
	int type_marker_i;
	int index_marker_i;
	int begin_end_accolade=0;
	int begin_end_instruct=0;
	int basic_line_2=0;
	int ASM_pos_2=0;
	strcpy (ASM_out, "");
	strcpy (ASM_temp_marker_subst, ASM_markers);
	ASM_m_remaining = ASM_temp_marker_subst;
	end_marker = ASM_m_remaining;
	begin_marker = strstr(ASM_m_remaining, "MARKER_");
	while (begin_marker!=0) {
		end_marker = strchr (begin_marker, '\n');
		begin_marker[0] = 0;
		end_marker[0] = 0;

		strcpy (marker_string, begin_marker+7);
		type_marker = strtok(marker_string, "_");
		index_marker = strtok(NULL, "_");
		
		if (strcmp(type_marker, "WHILE")==0) {type_marker_i=1; begin_end_accolade=1; begin_end_instruct=1;}
		if (strcmp(type_marker, "WEND")==0) {type_marker_i=2; begin_end_accolade=2; begin_end_instruct=2;}
		if (strcmp(type_marker, "ENDIF")==0) {type_marker_i=3; begin_end_accolade=2; begin_end_instruct=2;}
		if (strcmp(type_marker, "ENDELSE")==0) {type_marker_i=4; begin_end_accolade=2; begin_end_instruct=2;}
		if (strcmp(type_marker, "FOR")==0) {type_marker_i=5; begin_end_accolade=1; begin_end_instruct=3;}
		if (strcmp(type_marker, "NEXT")==0) {type_marker_i=6; begin_end_accolade=2; begin_end_instruct=2;}
		if (strcmp(type_marker, "LABEL")==0) {type_marker_i=7; begin_end_accolade=1; begin_end_instruct=1;}
		if (strcmp(type_marker, "SUBF")==0) {type_marker_i=8; begin_end_accolade=3; begin_end_instruct=1;}

		sscanf (index_marker, "%d", &index_marker_i);
		if (begin_end_accolade == 1) {basic_line_2 = accolade_basic_begin[index_marker_i];}
		if (begin_end_accolade == 2) {basic_line_2 = accolade_basic_end[index_marker_i];}
		if (begin_end_accolade == 3) {basic_line_2 = functions_basic_begin[index_marker_i];}
		
		if (begin_end_instruct == 1) {ASM_pos_2 = ASM_pos_begin [basic_line_2];}
		if (begin_end_instruct == 2) {ASM_pos_2 = ASM_pos_end [basic_line_2];}
		if (begin_end_instruct == 3) {ASM_pos_2 = ASM_pos_midfor [basic_line_2];}
		if (ASM_pos_2 == 0) {
			printf ("ERROR marker not found\r\n");
			exit (EXIT_FAILURE);
		}
		dec_to_hex(ASM_pos_2, ASM_address);
		strcat (ASM_out, ASM_m_remaining);
		strcat (ASM_out, ASM_address);
		strcat (ASM_out, "\n");
		ASM_m_remaining = end_marker + 1;
		begin_marker = strstr(ASM_m_remaining, "MARKER_");
	}
	strcat (ASM_out, ASM_m_remaining);
}

char ASM_out[500000];
char ASM_markers[500000];

int main(int argc, char* argv[])
{
	char filename_basic[20];
	int i,j,k;
	int expr_type;
	int size_code;
	int nb_lignes_basic;
	FILE* fid_out;
	int var_actual_size = 0;

	char ASM_temp[1000];
	char ASM_pos_temp[50];
	for (i = 0; i < 5000; i++) {accolade_basic_begin[i] = 0;}

	strcpy (ASM_markers, "");
	printf ("\r\n\r\n** A2Z COMPILER 001 **\r\n");
	strcpy(filename_basic,argv[1]);
	nb_lignes_basic=read_basic_file(filename_basic);
	
	manage_appli_config (nb_lignes_basic);

	functions_first_pass(nb_lignes_basic);
	
	manage_define (nb_lignes_basic); // before macro declarations (functions_second_pass)

	printf("\r\n    *** OBJECT: *** \r\n");
	declare_objects(nb_lignes_basic); //nb_objects=
	
	var_actual_size = allocate_objects(); //nb_objects
	
	functions_second_pass(nb_lignes_basic);

	printf("\r\n    *** EXPRESSIONS *** \r\n");
	ASM_pos_abs=0; 
	accolade_depth=0; 
	for (i=1; i<=nb_lignes_basic; i++) {
		ASM_pos_begin[i]=0;
		ASM_pos_end[i]=0;
		ASM_pos_midfor[i]=0;
		size_code =0; 
		ASM_pos_begin[i] = ASM_pos_abs;
		dec_to_hex (ASM_pos_abs, ASM_pos_temp);
		sprintf(ASM_temp, "/%d %s ", i, ASM_pos_temp);
		strcat (ASM_markers, ASM_temp);
		strcat(ASM_markers, basic_lines_indent[i]);
		strcat(ASM_markers, "\n");
		if (line_type[i]==label) {
			parse_label (basic_lines[i], i);
		}

		if (line_type[i]==instruction) {
			size_code = parse_instruction (basic_lines[i], ASM_temp, i, basic_lines_function[i]);
			if (size_code>0) {
				strcat(ASM_markers, ASM_temp);
			}

		}
		ASM_pos_end[i] = ASM_pos_abs;
		
	}

	printf("    code_size:%d\r\n", ASM_pos_abs);
	// check for code size
	if ( (ASM_pos_abs*2) >= (code_max_size-2) ) {
		printf ("ERROR code too big for %d bytes\r\n", code_max_size);
		exit (EXIT_FAILURE);
	}
	if (code_var_separation == 1) {
		if ( (ASM_pos_abs*2 + var_actual_size) >= (code_max_size-2) ) {
			printf ("ERROR code+var too big for %d bytes\r\n", code_max_size);
			exit (EXIT_FAILURE);	
		}
	}

	marker_substitute (ASM_markers, ASM_out);

	strcat (ASM_out, text_const_ASM);
	write_conf_file(filename_basic);
	write_ASM_file (filename_basic, ASM_out);
	write_obj_file (filename_basic);
	printf("* compiler SUCCESS, ASM generated *\r\n\r\n");

	return 0;
}

