
//

#include "stdafx.h"
#include "stdio.h"
#include "string.h"
#include "ctype.h"
#include <stdlib.h>

unsigned char file_content[2000000];

unsigned char palette_green[300];
unsigned char palette_red[300];
unsigned char palette_blue[300];

unsigned char color_search(unsigned char blue_raw, unsigned char green_raw, unsigned char red_raw){
	unsigned int i;
	int distance, min_distance;
	int delta_red, delta_green, delta_blue;

	min_distance = 10000;
	unsigned char out_color;
	for (i = 0; i <= 255; i++) {
		delta_blue = (blue_raw - palette_blue[i]);
		delta_green = (green_raw - palette_green[i]);
		delta_red = (red_raw - palette_red[i]);
		distance = delta_blue * delta_blue + delta_green * delta_green + delta_red * delta_red;
		if (distance < min_distance) {
			min_distance = distance;
			out_color = i;
		}
	}
	
	return out_color;
}

int main(int argc, char* argv[])
{
	unsigned char blue_raw;
	unsigned char red_raw;
	unsigned char green_raw;
	unsigned char lumin;
	unsigned int remaind;
	unsigned int i, j, k, l;
	unsigned char loc_value[20];
	//unsigned char palette_green[300];
	//unsigned char palette_red[300];
	//unsigned char palette_blue[300];
	unsigned char local_red, local_blue, local_green, loc_color;

	char size_x_req_txt[50];
	char size_y_req_txt[50];
	char offset_txt[50];
	char filename_raw[50];
	char filename_in[50];
	char filename_out[50];
	int size_x_req;
	int size_y_req;
	int size_tot;

	int size_file;
	int file_pos;
	FILE* fid_in;
	FILE* fid_out;

	if (argc != 5) {
		printf("ERROR, expecting 4 arguments, received %d\r\n", argc-1);
		printf("1: filename (without extension)\r\n");
		printf("2: x size\r\n");
		printf("3: y size\r\n");
		printf("4: memory offset\r\n");
		exit(EXIT_FAILURE);
	}

	strcpy(filename_raw, argv[1]);
	strcpy(size_x_req_txt, argv[2]);
	strcpy(size_y_req_txt, argv[3]);
	strcpy(offset_txt, argv[4]);

	strcpy(filename_in, filename_raw);
	strcat(filename_in, ".bmp");
	strcpy(filename_out, filename_raw);
	strcat(filename_out, ".bmpA2Z");

	sscanf(size_x_req_txt, "%d", &size_x_req);
	sscanf(size_y_req_txt, "%d", &size_y_req);

	printf("size requested X:%d Y:%d\r\n", size_x_req, size_y_req);

	fid_in = fopen(filename_in, "rb");

	size_file = fread(file_content, 1, 1900000, fid_in);
	printf("read %d bytes\r\n", size_file);

	fid_out = fopen(filename_out, "wb");

	// BMP PALETTE CREATION
	file_pos = 0x36;
	for (i = 0; i <= 255; i++) {
		red_raw = i / 64;
		remaind = i % 64;
		green_raw = remaind / 16;
		remaind = remaind % 16;
		blue_raw = remaind / 4;
		lumin = 16 * ((remaind % 4) + 2); // 1 or 2
		palette_blue[i] = blue_raw * lumin;
		palette_green[i] = green_raw * lumin;
		palette_red[i] = red_raw * lumin;
		//file_content[file_pos + 3] = 0xFF;
		//file_pos = file_pos + 4;
		//printf("col %x blue:%x green:%x red:%x\r\n", i, blue_raw * lumin, green_raw * lumin, red_raw * lumin);
	}
	printf("palette_ok\r\n");

	int x_pos, y_pos;
	for (y_pos = 0; y_pos <size_y_req; y_pos++) {
		for (x_pos = 0; x_pos < size_x_req; x_pos++) {
			//printf("pixel X:%d y:%d color %d\r\n", x_pos, y_pos, loc_value[0]);
			file_pos = 0x36 + 784 * 3 * (136 + size_y_req - y_pos) + 3 * (8 + x_pos);
			local_blue = file_content[file_pos];
			local_green = file_content[file_pos+1];
			local_red = file_content[file_pos+2];
			loc_value[0] = color_search(local_blue, local_green, local_red);
			//printf("pixel X:%d y:%d color %d\r\n", x_pos, y_pos, loc_value[0]);
			fwrite(loc_value, 1, 1, fid_out);
		}
	}

	//fwrite(file_content, 1, size_file, fid_out);
	fclose(fid_in);
	fclose(fid_out);

	//config file
	strcpy(filename_out, filename_raw);
	strcat(filename_out, ".conf");
	fid_out = fopen(filename_out, "w");
	size_tot = size_x_req*size_y_req;
	fprintf(fid_out, "%s %d", offset_txt, size_tot);
	fclose(fid_out);
	return 0;
}

