// palette_256.cpp: dfinit le point d'entre pour l'application console.
//

#include "stdafx.h"
#include "stdio.h"
#include "string.h"
#include "ctype.h"
#include <stdlib.h>

unsigned char file_content[2000000];

int main(int argc, char* argv[])
{
	unsigned char blue_raw;
	unsigned char red_raw;
	unsigned char green_raw;
	unsigned char lumin;
	unsigned int remaind;
	unsigned int i,j,k,l;
	unsigned char loc_value[20];
	unsigned char palette_green[300];
	unsigned char palette_red[300];
	unsigned char palette_blue[300];
	
	char size_x_req_txt[50];
	char size_y_req_txt[50];
	int size_x_req;
	int size_y_req;

	int size_file;
	int file_pos;
	FILE* fid_in;
	FILE* fid_out;

	strcpy(size_x_req_txt, argv[1]);
	strcpy(size_y_req_txt, argv[2]);

	sscanf(size_x_req_txt, "%d", &size_x_req);
	sscanf(size_y_req_txt, "%d", &size_y_req);
	printf("size requested X:%d Y:%d\r\n", size_x_req, size_y_req);

	fid_in = fopen("raw_2.bmp", "rb");

	size_file = fread(file_content, 1, 1900000, fid_in);
	printf("read %d bytes\r\n", size_file);

	fid_out = fopen("palette_2.bmp", "wb");
	
	

	//for (i = 0; i <= 255; i++) {
	//	red_raw = i / 64;
	//	remaind = i % 64;
	//	green_raw = remaind / 16;
	//	remaind = remaind % 16;
	//	blue_raw = remaind / 4;
	//	lumin = (remaind % 4) + 1; // 1 or 2
	//	loc_value[0] = blue_raw * lumin;
	//	loc_value[1] = green_raw * lumin;
	//	loc_value[2] = red_raw * lumin;
	//	loc_value[3] = 255;
	//	fwrite(loc_value, 1, 4, fid_out);
	//	printf("col:%d red:%d green:%d blue:%d lum:%d\r\n", i, red_raw, green_raw, blue_raw, lumin);
	//}

	// BMP PALETTE CREATION
	file_pos = 0x36;
	for (i = 0; i <= 255; i++) {
		red_raw = i / 64;
		remaind = i % 64;
		green_raw = remaind / 16;
		remaind = remaind % 16;
		blue_raw = remaind / 4;
		lumin = 16 * ((remaind % 4) + 2); // 1 or 2
		palette_blue[i] = blue_raw * lumin;
		palette_green[i] = green_raw * lumin;
		palette_red[i] = red_raw * lumin;
		//file_content[file_pos + 3] = 0xFF;
		//file_pos = file_pos + 4;
		//printf("col %x blue:%x green:%x red:%x\r\n", i, blue_raw * lumin, green_raw * lumin, red_raw * lumin);
	}

	int pal_line, pal_raw, case_line, case_raw;
	// PALETTE pads inside image
	for (pal_line = 0; pal_line <= 7; pal_line++) {
		for (pal_raw = 0; pal_raw <= 31; pal_raw++) {
			for (case_line = 0; case_line <= 15; case_line++) {
				for (case_raw = 0; case_raw <= 15; case_raw++) {
					
					file_pos = 0x36 + 784 * 3 * (16 * pal_line + case_line) + 3* (16 * pal_raw + case_raw) ;
					file_content[file_pos] = palette_blue[pal_raw + 32 * pal_line]; // Blue
					file_content[file_pos+1] = palette_green[pal_raw + 32 * pal_line]; // Green
					file_content[file_pos+2] = palette_red[pal_raw + 32 * pal_line]; // Red
				}
			}
		}
	}

	// borders dots
	// vertical lines
	j = 0;
	unsigned char color_fill;
	for (i = 0; i < size_y_req; i++) {
		//dot line filling
		j++;
		if (j == 8) { j = 0; }
		if (j >= 4) { color_fill = 0xFF; }
		else { color_fill = 0; }
		//left
		file_pos = 0x36 + 784 * 3 * (i + 136) + 3 * 7;
		file_content[file_pos] = color_fill;
		file_content[file_pos + 1] = color_fill;
		file_content[file_pos + 2] = color_fill;

		//right
		file_pos = 0x36 + 784 * 3 * (i + 136) + 3 * (size_x_req + 9);
		file_content[file_pos] = color_fill;
		file_content[file_pos + 1] = color_fill;
		file_content[file_pos + 2] = color_fill;
	}


	
	// horizontal lines
	j = 0;
	for (i = 0; i < size_x_req; i++) {
		//dot line filling
		j++;
		if (j == 8) { j = 0; }
		if (j >= 4) { color_fill = 0xFF; }
		else { color_fill = 0; }
		//lower
		file_pos = 0x36 + 784 * 3 * (135) + 3 * (8 + i);
		file_content[file_pos] = color_fill;
		file_content[file_pos + 1] = color_fill;
		file_content[file_pos + 2] = color_fill;

		//upper
		file_pos = 0x36 + 784 * 3 * (137 + size_y_req) + 3 * (8 + i);
		file_content[file_pos] = color_fill;
		file_content[file_pos + 1] = color_fill;
		file_content[file_pos + 2] = color_fill;
	}

	fwrite(file_content, 1, size_file, fid_out);
	fclose(fid_in);
	fclose(fid_out);

	return 0;
}

